;=========================================================;
; Terminal                                       02/02/05 ;
;---------------------------------------------------------;
;                                                         ;
; (c) Craig Bamford, All rights reserved.                 ;
;=========================================================;
 ;----------------------------------------------------;
 ; Ready prompt.                                      ;
 ;----------------------------------------------------;

ReadyPrompt:
	mov   [textcolor],0x07 
	mov   [screen_x],0 
	mov   [screen_y],4
	call  set_cursor_pos
	ret
 
 ;----------------------------------------------------;
 ; Prompt.                                            ;
 ;----------------------------------------------------;

Prompt:
	pushad
	mov   al,[textcolor]
	mov   [textcolorsave],al 
	mov   [textcolor],0x09
	cmp   [PromptLetter],'A'
	jne   @f
	mov   esi,Aprompt
	call  print_string
	cmp   [RootYesNoA],0  
	je    ItsTheAdir  
	mov   esi,FolderNameA
	call  print_string
	jmp   ItsTheAdir
@@:
	cmp   [PromptLetter],'C'
	jne   @f
	mov   esi,Cprompt
	call  print_string
	cmp   [RootYesNoC],0  
	je    ItsTheAdir  
	mov   esi,FolderNameC
	call  print_string
	jmp   ItsTheAdir
@@:
	mov   esi,Dprompt
	call  print_string
ItsTheAdir:
	mov   esi,promptEnd
	call  print_string
	mov   al,[textcolorsave]
	mov   [textcolor],al
	popad
	ret

 ;----------------------------------------------------;
 ; StartUpPrompt.                                     ;
 ;----------------------------------------------------;
StartUpPrompt:
	pushad
	mov   al,[textcolor]
	mov   [textcolorsave],al 
	mov   [textcolor],0x09
	cmp   [PromptLetter],'A'
	jne   @f
	mov   esi,Aprompt
	call  print_string
	mov   [textcolor],0x07
	mov   esi,Loadmsg1
	call  print_string
	jmp   ItsTheAdirStartUP
@@:
	cmp   [PromptLetter],'C'
	jne   @f
	mov   esi,Cprompt
	call  print_string
	mov   [textcolor],0x07
	mov   esi,Loadmsg1
	call  print_string
	jmp   ItsTheAdirStartUP
@@:
	mov   esi,Dprompt
	call  print_string
	mov   [textcolor],0x07
	mov   esi,Loadmsg1
	call  print_string
ItsTheAdirStartUP:
	mov   al,[textcolorsave]
	mov   [textcolor],al
	popad
	ret

 ;----------------------------------------------------;
 ; Topbar.                                            ;
 ;----------------------------------------------------;

InitTopBar:
	pushad
	push  es
	mov   ax,8h
	mov   es,ax
	mov   edi,0xb8000
	mov   esi,TopBarMem
	mov   ah,0x09  
	mov   ecx,80*3	;4  
ClearTopBarLoop:  
	mov   al,[ds:esi]
	stosw
	inc   esi
	loop  ClearTopBarLoop
 ;----------------------------------------------------;
 ; Logo.                                              ;
 ;----------------------------------------------------;
	pop   es
	popad
	ret
Logo:
	pushad
	push  es
	mov   ax,8h
	mov   es,ax
	mov   edi,0xb8000
	add   edi,80*1*2
	add   edi,2 
	mov   dl,198
	mov   dh,0x09  
	mov   ecx,2 
LogoVerLoop: 
	push  ecx
	mov   ecx,6
	cld
LogoHorLoop:
	mov   ax,dx
	stosw
	inc   dl
	loop  LogoHorLoop
	add   edi,(80-6)*2
	pop   ecx
	loop  LogoVerLoop
	pop   es
	popad
	ret

 ;----------------------------------------------------;
 ; PALETTE                                            ;
 ;----------------------------------------------------;

Palette:
	pushad
	mov   dx,3c8h					 
	out   dx,al
	inc   dx					
	mov   al,bl					 
	out   dx,al
	mov   al,bh					 
	out   dx,al
	mov   al,cl					 
	out   dx,al
	popad
	ret

 ;----------------------------------------------------;
 ; Set a nifty color palette                          ;
 ;----------------------------------------------------;

SetPalette:
	mov   al,2
	mov   bx,0x3f3f
	mov   cl,43
	call  Palette					    
	mov   al,4
	mov   cl,63
	call  Palette					      
	mov   al,5
	mov   bx,0x3228
	call  Palette					       
	mov   al,7
	call  Palette				       
	mov   al,5
	mov   bx,0x0032
	mov   cl,0
	call  Palette	 
	mov   al,58
	mov   bx,0x0A00
	call  Palette	   
	inc   al
	mov   bh,40
	call  Palette	
	mov   al,56
	mov   bx,0x1010
	mov   cl,32
	call  Palette  
	mov   al,60
	mov   bx,0x1818
	mov   cl,48
	call  Palette  
	ret

LoadMsg:
	pushad
	mov   esi,Loadmsg1
	call  print_string
	popad
	ret
       

 ;----------------------------------------------------;
 ; Data                                               ;
 ;----------------------------------------------------;


TopBarMem    DB 'Ĵ (C) Team DexOS Ŀ'
	     DB 'DexOS                                                                         '
	     DB ''						   
		
     

PromptLetter db 0  
promptEnd    db '>',0	
Aprompt      db 'A:\',0
Cprompt      db 'C:\',0
Dprompt      db 'D:\',0
Loadmsg1     db 'LOADING DRIVERS...',13,13,0
Flashprompt  db  0x05f,0