;=========================================================;
; Fdd info                                       11/12/03 ;
;---------------------------------------------------------;
;                                                         ;
; (c) Craig Bamford, All rights reserved.                 ;
;=========================================================;

DorReg		  =   0x3f2				 ; digital output register (write only).
MsReg		  =   0x3f4				 ; main status register (read only).
DtReg		  =   0x3f5				 ; data register (read/write).
CcrReg		  =   0x3f7				 ; configuration control register.

Sr0_AbTerm	  =   6 				 ; test if aborted
Sr0Seek 	  =   5 				 ; test if seek ok

FddChanged	  =   6 				 ; error code for disk change.
FddTimeOut	  =   0x80				 ; error code for time out.
FddNoChange	  =   0x00				 ; No disk change.

FddErrorSeekFail  =   0x40				 ; error code for seek command has failed.
FddError_TimeOut  =   0x80				 ; error code for time out.

FddMotorTimer0n       db 0				 ; is the time on,to turn the floppy motor off 1= yes,0 =no.
FddMTimer	      db 0				 ; how many clock ticks, before turning floppy motor off
MotorOn 	      db 0				 ; is the motor on yes "MotorOn" = 1, no = 0
Head		      db 0				 ; store the head/side.
DriveHead	      db 0				 ; store head + drive.
cTrack		      db 0				 ; store track/cylinder
Sector		      db 0				 ; store Sector

FddErrorStatus	      db 0				 ; this the error code 00 = no error
CommandTry	      db 0				 ; number of times to try command,before error.

ResultST0	      db 0
ResultST1	      db 0				 ; or pcn
ResultST2	      db 0
ResultC 	      db 0
ResultH 	      db 0
ResultR 	      db 0
ResultN 	      db 0
ResultExtra	      db 0
ResultST3	      db 0
FloppyTest	      db 0

FddDrive	      db 0