;=======================================================================;
;                                                                       ;
;          MS-DOS FAT -- File Allocation Table Structures               ;
;                                                                       ;
;=======================================================================;
;====================================================;
;  ROOT DIR                                          ;
;====================================================;
RootDirBuffer	       rb	512 * 32
;====================================================;
;  Directory Entry format file                       ;
;====================================================;
FileEntry:		
FileName		rb	8		; 0x00
FileExten		rb	3		; 0x08
FileAttr		rb	1		; 0x0B
FileReserved		rb	1		; 0x0C
FileCreate10MS		rb	1		; 0x0D
FileCreateTime		rw	1		; 0x0E
FileCreateDate		rw	1		; 0x10
FileAccessDate		rw	1		; 0x12
FileClusterHigh 	rw	1		; 0x14
FileTime		rw	1		; 0x16
FileDate		rw	1		; 0x18
FileCluster		rw	1		; 0x1A
FileSize		rd	1		; 0x1C

;====================================================;
;  Directory Entry format                            ;
;====================================================;       
DirEntry:		
dirName 		rb	8		; 0x00
dirExten		rb	3		; 0x08
dirAttr 		rb	1		; 0x0B
dirReserved		rb	1		; 0x0C
dirCreate10MS		rb	1		; 0x0D
dirCreateTime		rw	1		; 0x0E
dirCreateDate		rw	1		; 0x10
dirAccessDate		rw	1		; 0x12
dirClusterHigh		rw	1		; 0x14
dirTime 		rw	1		; 0x16
dirDate 		rw	1		; 0x18
dirCluster		rw	1		; 0x1A
dirSize 		rd	1		; 0x1C

;====================================================;
;  Directory Entry format                            ;
;====================================================;       
DirEntry1:
dirName1		rb	8		; 0x00
dirExten1		rb	3		; 0x08
dirAttr1		rb	1		; 0x0B
dirReserved1		rb	1		; 0x0C
dirCreate10MS1		rb	1		; 0x0D
dirCreateTime1		rw	1		; 0x0E
dirCreateDate1		rw	1		; 0x10
dirAccessDate1		rw	1		; 0x12
dirClusterHigh1 	rw	1		; 0x14
dirTime1		rw	1		; 0x16
dirDate1		rw	1		; 0x18
dirCluster1		rw	1		; 0x1A
dirSize1		rd	1		; 0x1C

;Somespace               rb      512*66*2

;====================================================;
;  BPB for FAT12 volumes                             ;
;====================================================;
BpbFat12:
bsJmp			rb	3		; 0x00
bsOemName		rb	8		; 0x03
bsFat12:			
bpbBytesPerSector	rw	1		; 0x0B
bpbSectorsPerCluster	rb	1		; 0x0D
bpbReservedSectors	rw	1		; 0x0E
bpbNumberOfFATs 	rb	1		; 0x10
bpbRootEntries		rw	1		; 0x11
bpbTotalSectors 	rw	1		; 0x13
bpbMedia		rb	1		; 0x15
bpbSectorsPerFAT	rw	1		; 0x16
bpbSectorsPerTrack	rw	1		; 0x18
bpbHeadsPerCylinder	rw	1		; 0x1A
bpbHiddenSectors	rd	1		; 0x1C
bpbTotalSectorsBig	rd	1		; 0x20
bsDriveNumber		rb	1		; 0x24
bsUnused		rb	1		; 0x25
bsExtBootSignature	rb	1		; 0x26
bsSerialNumber		rd	1		; 0x27
bsVolumeLabel		rb	11		; 0x2B   ; "NO NAME    "
bsFileSystem		rb	8		; 0x36   ; "FAT12   "   
bsBootCode		rb	450		; 0x3E

;====================================================;
;  FAT                                               ;
;====================================================;
Fat:
Fat1		       rb	512 * 256
suecraig:	




