;=========================================================;
; Fat16                                          11/12/06 ;
;---------------------------------------------------------;
;                                                         ;
; (c) Craig Bamford, All rights reserved.                 ;
;=========================================================;

;====================================================;
; DirFillRootFat16.                                  ;
;====================================================;
DirFillRootFat16:
	pushad
	cmp   [ReadOneSectorFatVar],0
	jne   DirFillRootFat16Succsess
DirFillRootHddFat16:
	mov   ax,word[bpbHiddenSectors1]
	mov   dx,word[bpbHiddenSectors1+2]
	add   ax,word [bpbReservedSectors1]
	mov   [FatStartDxFat16],dx
	mov   [FatStartFat16],ax
	xor   eax,eax
	mov   ecx,eax			
	mov   al, byte [bpbNumberOfFATs1]		 
	mul   word [bpbSectorsPerFAT1]	
	mov   [FatSize2Fat16],ax
	xor   eax,eax	
	mov   ax,word [bpbSectorsPerFAT1]
	mov   [FatSize1Fat16],ax
	mov   ax,[bpbRootEntries1]			
	mov   cx, 32					
	mul   cx					
	div   word [bpbBytesPerSector1] 		 
	mov   [RootSizeFat16],ax			
 ;----------------------------------------------------;
 ; Root Dir Location - Reserved sectors + Fat sectors ;
 ;----------------------------------------------------;
	xor   eax,eax
	mov   edx,eax			
	mov   al, byte [bpbNumberOfFATs1]		 
	mul   word [bpbSectorsPerFAT1]			 
	add   ax, [FatStartFat16]    
	mov   [RootStartDxFat16],dx	       
	mov   [RootStartFat16],ax			     
 ;----------------------------------------------------;
 ; Data start Reserved sectors + FAT sectors + Root   ;
 ;----------------------------------------------------;
	mov   cx,[RootSizeFat16]			   
	add   ax,cx					
	mov   [DataStartFat16],ax  
	mov   [FloppyTestFat16],0
	mov   [FileLoadCountFat16],0
	mov   [Fat16SectorsLoadedCount],0
	mov   edi,FatHdd		      
	mov   [LoadFileToAddressFat16],edi 
	xor   eax,eax
	mov   ecx,eax
	mov   dx,[FatStartDxFat16]
	mov   ax,[FatStartFat16] 
	mov   cx,[FatSize1Fat16]   
ReadSectorsLoopFat16a:
	mov   [FloppyTestFat16],0
	call  ReadSectorsFat16
	jc    DirErrorFat16  
	inc   ax
	loop  ReadSectorsLoopFat16a
	mov   [FloppyTestFat16],0
	mov   [FileLoadCountFat16],0
	mov   [Fat16SectorsLoadedCount],0
	mov   edi,RootDirBufferHdd	      
	mov   [LoadFileToAddressFat16],edi 
	xor   eax,eax
	mov   dx,[RootStartDxFat16]
	mov   ax,[RootStartFat16] 
	mov   cx,[RootSizeFat16]  
ReadSectorsLoopFat16b:
	mov   [FloppyTestFat16],0
	call  ReadSectorsFat16
	jc    DirErrorFat16 
	inc   ax
	loop  ReadSectorsLoopFat16b
	xor   eax,eax
	mov   [Fat16count],0
	mov   ax,word [bpbSectorsPerFAT1]		 
	shl   eax,9					
	shr   eax,1					
	cmp   eax,4086					 
	jb    DirFillRootFat16Succsess			  
DirFillRootFat16Succsess:
	mov   [ReadOneSectorFatVar],1
	popad
	clc
	ret 

DirErrorFat16:
	popad
	stc
	ret

 ;----------------------------------------------------;
 ; LoadFolderHddFat16.                                ;
 ;----------------------------------------------------;
LoadFolderHddFat16:
	pushad				  
	push  es
	push  ds 
	mov   [HddFileName],edi
	mov   [LoadFileToAddressFat16],edx		    
	mov   [FileLoadCountFat16],0			    
	mov   [Fat16SectorsLoadedCount],0		    
	mov   edi,RootDirBufferHdd 
	mov   [RootDirBufferVarC],edi
	xor   ecx,ecx					    
	mov   ax,[bpbRootEntries1]			    
	mov   cx, 32					    
	mul   cx					    
	div   word [bpbBytesPerSector1] 		    
	mov   [RootSizeFat16],ax			    
 ;----------------------------------------------------;
 ; Root Dir Location - Reserved sectors + Fat sectors ;
 ;----------------------------------------------------;
	mov   dx,ax	
	xor   ax,ax			
	mov   al, byte [bpbNumberOfFATs1]		 
	mul   word[bpbSectorsPerFAT1]			 
	add   ax,word[FatStartFat16]			  
	mov   [RootStartFat16],ax			     
	mov   [RootStartDxFat16],dx 
 ;----------------------------------------------------;
 ; Data start Reserved sectors + FAT sectors + Root   ;
 ;----------------------------------------------------;
	mov   cx,[RootSizeFat16]			     
	add   ax,cx					    
	mov   [DataStartFat16],ax			    
	mov   ax,18h					    
	mov   es,ax
	mov   ds,ax
       ; mov   edi,RootDirBufferHdd                              
	mov   edi,[RootDirBufferVarC]
	mov   esi,[HddFileName] 			
	mov   dx,[bpbRootEntries1]
 ;----------------------------------------------------;
 ; FindNameFat16.                                     ;
 ;----------------------------------------------------;
	mov   cx,11
	jmp   FindNameCycleFat16

 ;----------------------------------------------------;
 ; RunCommandHddFat16.                                ;
 ;----------------------------------------------------;
RunCommandHddFat16:
	pushad				  
	push  es
	push  ds
	mov   [FileReadBytes],0
	mov   [HddFileName],edi
	mov   [LoadFileToAddressFat16],edx
	mov   [FileLoadCountFat16],0
	mov   [Fat16SectorsLoadedCount],0		  
	mov   edi,RootDirBufferHdd 
	mov   [RootDirBufferVarC],edi
	cmp   [RootYesNoC],0
	je    @f
	mov   [RootDirBufferVarC],0x110000
@@:
	xor   ecx,ecx
	mov   ax,[bpbRootEntries1]			   
	mov   cx, 32					    
	mul   cx					    
	div   word [bpbBytesPerSector1] 		 
	mov   [RootSizeFat16],ax			    
 ;----------------------------------------------------;
 ; Root Dir Location - Reserved sectors + Fat sectors ;
 ;----------------------------------------------------;
	mov   dx,ax	
	xor   ax,ax			
	mov   al, byte [bpbNumberOfFATs1]		 
	mul   word[bpbSectorsPerFAT1]			 
	add   ax,word[FatStartFat16]			  
	mov   [RootStartFat16],ax			     
	mov   [RootStartDxFat16],dx 
 ;----------------------------------------------------;
 ; Data start Reserved sectors + FAT sectors + Root   ;
 ;----------------------------------------------------;
	mov   cx,[RootSizeFat16]			     
	add   ax,cx					    
	mov   [DataStartFat16],ax			     
	mov   ax,18h					    
	mov   es,ax
	mov   ds,ax
	mov   edi,[RootDirBufferVarC]
	mov   esi,[HddFileName] 			
	mov   dx,[bpbRootEntries1]
 ;----------------------------------------------------;
 ; FindNameFat16.                                     ;
 ;----------------------------------------------------;
FindNameFat16:
	mov   cx,11
FindNameCycleFat16:
	cmp   byte [es:edi],ch
	je    FindNameFailedFat16			      
	pushad					       
	repe  cmpsb
	popad					       
	je    FindNameFoundFat16
	add   edi, 32
	dec   dx
	jnz   FindNameCycleFat16			      
FindNameFailedFat16:
	jmp   ErrorFindFat16b
FindNameFoundFat16:
	mov   dx,word[es:edi+1Ah]			   
	mov   word [cluster],dx 		       
	mov   word [FirstFolderCluster],dx
	mov   eax,dword[es:edi+1Ch]
	mov   [FileReadBytes],eax
	xor   eax,eax
 ;----------------------------------------------------;
 ; Fat16.                                             ;
 ;----------------------------------------------------;
LoadImageFat16b:
	mov   ax,[cluster]			       
	mov   [FloppyTestFat16],0			    
ReadNextClusterFat16b:					    
	call  ClusterLBAFat16 ;ClusterLBA                                   
	mov   [clusterSPC],ax			       
	xor   ecx,ecx					   
	mov   cl,byte [bpbSectorsPerCluster1]		
ReadNextClusterFat16loopb:
	push  ecx					   
	mov   [FloppyTestFat16],0			    
	call  ReadSectorsFat16					 
	jc    ErrorFloppyPopFat16				
	inc   [clusterSPC]					    
	mov   ax,[clusterSPC]			       
	pop   ecx					   
	loop  ReadNextClusterFat16loopb 		    
 ;----------------------------------------------------;
 ; compute next cluster.                              ;
 ;----------------------------------------------------;
	xor   ecx,ecx
	xor   eax,eax
	mov   ax,word[cluster]			       
	mov   cx,ax					   
	add   ecx,eax					   
	mov   esi,FatHdd ;Fat                                      
	
	add   esi,ecx					   
	mov   dx,word [ds:esi]				   
	mov   word [cluster],dx 		       
	cmp   dx,0xFFF0 				   
	jb    LoadImageFat16b
 ;----------------------------------------------------;
 ; ExitSucsessFat16b.                                 ;
 ;----------------------------------------------------;
ExitSucsessFat16b:
	pop   ds
	pop   es
	popad
	mov   ebx,[Fat16SectorsLoadedCount]
	mov   ecx,[FileReadBytes]
	clc
	ret 
 ;----------------------------------------------------;
 ; ErrorFindFat16b.                                   ;
 ;----------------------------------------------------;        
ErrorFindFat16b:
	pop   ds
	pop   es
	popad
	stc
	ret
 ;----------------------------------------------------;
 ; ErrorFloppyFat16.                                  ;
 ;----------------------------------------------------; 
ErrorFloppyPopFat16:
	pop   ecx 
ErrorFloppyFat16:
	pop   ds
	pop   es
	popad
	stc
	ret

 ;----------------------------------------------------;
 ; ReadSectorsFat16.                                  ;
 ;----------------------------------------------------;
ReadSectorsFat16:
	pushad
	push  es
	push  ds
	call  LBAcHsFat16
TryReadFloppyAgainFat16: 
	mov   ch,byte [absoluteTrackFat16]		     
	mov   cl,byte [absoluteSectorFat16]		     
	mov   dh,byte [absoluteHeadFat16]		     
	mov   dl, 80h ;byte [bsDriveNumber]  
	call  FddReadB
	jnc   FloppyReadOkFat16
 ;----------------------------------------------------;
 ; Try Reading Hdd 3 time.                            ;
 ;----------------------------------------------------;
	inc   [FloppyTestFat16]
	cmp   [FloppyTestFat16],1
	jae   @f
	jmp   TryReadFloppyAgainFat16
 ;----------------------------------------------------;
 ; Move data from DMA buffer, to image address.       ;
 ;----------------------------------------------------;
FloppyReadOkFat16:
	mov   cx,512	    
	mov   ax,18h  
	mov   ds,ax
	mov   es,ax  
	mov   esi,[buff]
	mov   edi,[LoadFileToAddressFat16]	 
	add   edi,[FileLoadCountFat16]	
	rep   movsb
	mov   byte[es:edi],0 
	add   [FileLoadCountFat16],512
	add   [Fat16SectorsLoadedCount],1		  
 ;----------------------------------------------------;
 ; ExitSucsess.                                       ;
 ;----------------------------------------------------;
	pop   ds
	pop   es
	popad
	clc
	ret 

 ;----------------------------------------------------;
 ; Error.                                             ;
 ;----------------------------------------------------;
@@:
	pop   ds
	pop   es
	popad
	stc
	ret 
       
 ;----------------------------------------------------;
 ; LBAcHsFat16.                                       ;
 ;----------------------------------------------------;
LBAcHsFat16:
	;xor   dx,dx                                     
	div   word [bpbSectorsPerTrack1]		 
	inc   dl					
	mov   byte [absoluteSectorFat16],dl
	xor   dx,dx					
	div   word [bpbHeadsPerCylinder1]		 
	mov   byte [absoluteHeadFat16],dl
	mov   byte [absoluteTrackFat16],al
	ret

 ;----------------------------------------------------;
 ; ClusterLBAFat16.                                   ;
 ;----------------------------------------------------;
ClusterLBAFat16:
	sub   ax,2					
	xor   cx,cx					
	mov   cl,byte [bpbSectorsPerCluster1]		
	mul   cx					
	add   ax, word [DataStartFat16] 	       
	ret	

 ;----------------------------------------------------;
 ; HddWriteFat16 Bios                                 ;
 ;----------------------------------------------------;
 ;                                                    ;
 ;   Input:                                           ;
 ;       ES:BX  = Buffer address                      ;
 ;          CH  = Track/cylinder                      ;
 ;          CL  = Sector                              ;
 ;          DH  = Head                                ;
 ;          DL  = Drive                               ;
 ;          AL  = Number of sectors (normaly 1)       ;
 ;          AH  = WriteSector(03h)                    ;
 ;                                                    ;
 ;  Output:                                           ;
 ;          AH  = Status                              ;
 ;          AL  = Sector number read                  ;
 ;          CF  = 0 If successful                     ;
 ;              = 1 If error                          ;
 ;                                             (100%) ;
 ;....................................................;
HddWriteFat16:
	pushad
	push  es
	push  ds
	mov   [FloppyTestFat16],0 
	mov   dword[FileAddresFat16],esi
	push  eax
	push  ecx
	mov   ax,18h
	mov   es,ax
	mov   ds,ax
	mov   edi,OffsetDma2Buffer1
	mov   eax,0x00000000
	mov   ecx,128
	cld
	rep   stosd
	mov   edi,OffsetDma2Buffer1
	mov   esi,dword[FileAddresFat16]
	mov   ecx,128
	cld
	rep   movsd
	pop   ecx
	pop   eax
	mov   [FddErrorStatus],0x04  
	mov   al,01		      
	mov   dl,80h ;[FddDrive]
	mov   byte[RealModeError],0
	mov   word[RealModeAX],ax
	mov   word[RealModeBX],bx
	mov   word[RealModeCX],cx
	mov   word[RealModeDX],dx
	call  mask_irqs
	mov   al,11h
	out   0x20,al
	out   0xA0,al
	mov   al,0x08
	out   0x21,al
	mov   al,0x70
	out   0xA1,al
	mov   al,4
	out   0x21,al
	mov   al,2
	out   0xA1,al
	mov   al,1
	out   0x21,al
	out   0xA1,al
	jmp   0x20:do_16Int13hWriteFat16
use16
do_16Int13hWriteFat16:	
	mov   ax,0x28
	mov   ds,ax
	mov   ss,ax
	nop
 ;----------------------------------------------------;
 ; push real-mode CS:IP.                              ;
 ;----------------------------------------------------;  
	mov   bx,[RealModeCS]
	push  bx
	lea   bx,[do_rmInt13hWriteFat16]
	push  bx
 ;----------------------------------------------------;
 ; clear PE [pmode enable] bit and return to Rmode.   ;
 ;----------------------------------------------------; 
	mov   eax,cr0
	and   al,0xFE
	mov   cr0,eax
	retf
 ;----------------------------------------------------;
 ;  16-bit real mode again                            ;
 ;----------------------------------------------------;                                   
do_rmInt13hWriteFat16:	
	mov   ax,cs
	mov   ds,ax
	mov   ss,ax
	nop
	mov   es,ax
	mov   fs,ax
	mov   gs,ax
 ;----------------------------------------------------;
 ; point to real-mode IDTR.                           ;
 ;----------------------------------------------------; 
	lidt  [ridtr]
	push  cs
	pop   ds
	push  ds
	pop   es
 ;----------------------------------------------------;
 ;  Do real mode interrupts                           ;
 ;----------------------------------------------------;
TryWriteHddFat16FloppyAgainRM:
	mov   ax,word[RealModeAX]
	mov   bx,word[RealModeBX]
	mov   cx,word[RealModeCX]
	mov   dx,word[RealModeDX]   
	mov   bx,OffsetDma2Buffer1 
	mov   ah,03h
	int   13h
	jnc   @f

	inc   [FloppyTestFat16]
	cmp   [FloppyTestFat16],4
	jae   RmHddError
	mov   dx,word[RealModeDX]
	mov   ah,00
	int   13h
	jmp   TryWriteHddFat16FloppyAgainRM
RmHddError:
	mov   byte[RealModeError],1
@@:
	mov   word[RealModeAX],ax
	mov   word[RealModeBX],bx
	mov   word[RealModeCX],cx
	mov   word[RealModeDX],dx
 ;----------------------------------------------------;
 ;  Lets go back to pmode                             ;
 ;----------------------------------------------------;      
	lgdt  [gdtr]					  
	lidt  [idtr]
	mov   eax,cr0					  
	or    al,1
	mov   cr0,eax
 ;----------------------------------------------------;
 ;  jumps to do_pm                                    ;
 ;----------------------------------------------------;
	jmp   sys_code:do_pmInt13hWriteFat16
 ;----------------------------------------------------;
 ;  32-bit protected mode                             ;
 ;----------------------------------------------------;
use32
do_pmInt13hWriteFat16:
	mov   ax,sys_data
	mov   ds,ax
	mov   ss,ax
	nop
	mov   es,ax
	mov   fs,ax
	mov   gs,ax
	mov   ax,8h
	mov   fs,ax
	call  remap_pic
	call  unmask_irqs
	cmp   [RealModeError],1
	je    FddWriteError1Fat16
	pop   ds
	pop   es
	popad					     
	mov   ax,word[RealModeAX]
	clc
	ret

FddWriteError1Fat16: 
	pop   ds 
	pop   es
	popad	     
	mov  ax,word[RealModeAX]
	stc
	ret

FileAddresFat16  dd 0
 ;----------------------------------------------------;
 ;  Data.                                             ;
 ;----------------------------------------------------;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; WriteFileHdd.                                                                    ;;
;; This part of the code is from when i decide to comment the code,                 ;;
;; and this is as far as i got.                                                     ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
WriteFileHdd:					    ; Name of function.
	mov   [ErrorCodeFat16],0		    ; Make sure the var is 0.
	mov   [HddSectorsWriteCountFat16],0	    ; Make sure the var is 0.
	mov   [FileLoadCountFat16],dword 0	    ; Make sure the var is 0.
	mov   dword[NameOfFileToMakeFat16],esi	    ; ESI should point to name of file, save it.
	mov   dword[LoadFileFromAddressFat16],edi   ; EDI should point to address of file, save it.
	mov   dword[FileSizeInBytesFat16],eax	    ; EAX should = file size in bytes, save it.
	mov   byte[ErrorCodeFat16],8		    ; Return error code.
	cmp   byte[ds:esi],' '			    ; Check that the file name is valid.
	je    writeCommandNameErrorFat16	    ; If not jump to exit and set error flag.
	cmp   byte[ds:esi],0			    ; Check that the file name is valid.
	je    writeCommandNameErrorFat16	    ; If not jump to exit and set error flag.
	call  LoadMBR				    ; Make sure MBR has bean loaded.
	jc    writeCommandNameErrorFat16		; If we have a error jump exit, set error flag.
	call  ReadOneSector			    ; Load FAT and ROOT dir.       
	jc    writeCommandNameErrorFat16		; If we have a error jump exit,set error flag.
	pushad					    ; Save 32bit general registers.
	push  es				    ; Save ES.
	push  ds				    ; Save DS.
	mov   ax,18h				    ; Move data descriptors into AX.
	mov   ds,ax				    ; Now add AX to DS (NO direct segment reg addressing).       
	mov   es,ax				    ; Now add AX to ES (NO direct segment reg addressing). 
	mov   edi,FileEntry			    ; Point edi to file entry address.
	mov   ecx,8				    ; Move 8 into count reg.
	mov   eax,0x00000000			    ; Make sure EAX is 0.
	cld					    ; L to R
	rep   stosd				    ; Fill dir entry with 0.
	mov   edi,RootDirBufferHdd		    ; Load root buffer into edi.
	mov   [RootDirBufferVarC],edi		    ; Store it.
	cmp   [RootYesNoC],0			    ; Check if we are writing to root dir.
	je    WriteFileRootDir			    ; Miss next bit if we are.
	cmp   byte[FatID],16			    ; Check for fat16.
	jne   TryFat32SysWritea 		    ; If not try Fat32.
	call  HddFat16WriteFolder		    ; If fat16 call function.
	jc    writeCommandErrorFat16		    ; Test if it returns with error.
	jmp   WriteFileHddSucsess		    ; If not jump to sucess.
TryFat32SysWritea:				    ; Label.
	cmp   byte[FatID],32			    ; Check for fat32.
	jne   writeCommandErrorFat16		    ; If not we have a error.
	call  HddFat32WriteFolder		    ; Call the function.
	jc    writeCommandErrorFat16		    ; test for errors.
	jmp   WriteFileHddSucsess		    ; if not we have sucess
WriteFileRootDir:				    ; Label.
	cmp   byte[FatID],16			    ; Check for fat16.
	jne   TryFat32SysWriteb 		    ; If not try Fat32.
	call  HddFat16WriteRoot 		    ; If fat16 call function.
	jc    writeCommandErrorFat16		    ; Test if it returns with error.
	jmp   WriteFileHddSucsess		    ; If not jump to sucess.
TryFat32SysWriteb:				    ; Label.
	cmp   byte[FatID],32			    ; Check for fat32.
	jne   writeCommandErrorFat16		    ; If not we have a error.
	call  HddFat32WriteRoot 		    ; Call the function
	jc    writeCommandErrorFat16		    ; test for errors.
	jmp   WriteFileHddSucsess		    ; if not we have sucess.
WriteFileHddSucsess:				    ; Label.
	pop   ds				    ; Restore DS.
	pop   es				    ; Restore DS.
	popad					    ; Restore 32bit general registers.
	mov   ebx,dword[HddSectorsWriteCountFat16]  ; Number of Sectors written.
	mov   edx,NameOfFileToLoadBufferFat16	    ; Name of file written.
	mov   ah,0				    ; Mark no errors.
	clc					    ; No errors :).
	ret					    ; Return.

writeCommandErrorFat16: 			    ; Label.
	pop   ds				    ; Restore DS.
	pop   es				    ; Restore ES.
	popad					    ; Restore 32bit general registers.
	mov   ah,byte[ErrorCodeFat16]		    ; Return error code.
	stc					    ; Error :(.
	ret					    ; Return.

writeCommandNameErrorFat16:			    ; Label.
	mov   ah,byte[ErrorCodeFat16]		    ; Return error code.
	stc					    ; Error :(.                   
	ret					    ; Return.

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; HddFat16WriteRoot.                                                               ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
HddFat16WriteRoot:				    ; Name of function.
	mov   eax,dword[FileSizeInBytesFat16]	    ; Load eax with file size
	call  GetFileSizeInClusters		    ; Convert file size from bytes, to number of clusters.
	call  UsedSectorsFat16Write		    ; We need to see if theres any space on the hdd.
	mov   [ErrorCodeFat16],5		    ; Put the right error code in error var, for next bit.
	mov   eax,dword[FreeClustersFat16]	    ; We need to move nunber of free clusters into a reg, as memory to memory is not possable
	cmp   [FileSizeInClustersFat16],eax	    ; Can we fit the file on the Hdd ?.
	ja    writeCommandErrorFat16ABC 	    ; If not end with error.
	mov   [ErrorCodeFat16],0		    ; Put the right error code in error var, for next bit.
	call  FindNextFreeRootEntryFat16	    ; Need to find a free root entry.
	jc    writeCommandErrorFat16ABC 	    ; If we have a error jump exit, set error flag.
	mov   esi,dword[NameOfFileToMakeFat16]	    ; We need the address of file towrite for next function, in esi.
	call  MakeNewFileFat16			    ; Call function.
	jc    writeCommandErrorFat16ABC 	    ; If we have a error jump exit, set error flag.
	call  FillOutRootEntryFAT16		    ; Put name of file in root dir entry.
	call  UpdateClusterChainHddFat16	    ; Up date FAT.
	jc    writeCommandErrorFat16ABC 	    ; If we have a error jump exit, set error flag.
	call  WriteFat16			    ; Write file to Hdd
	mov   dword[HddSectorsWriteCountFat16],ebx  ; EBX is returned with number of sector wrote to hdd.
	jc    writeCommandErrorFat16ABC 	    ; If we have a error jump exit, set error flag.
	call  DirFatRootUpdateFat16		    ; If not errors write new root and fat to hdd.
	jc    writeCommandErrorFat16ABC 	    ; If we have a error jump exit, set error flag.
	clc					    ; No errors :).
	ret					    ; Return.

writeCommandErrorFat16ABC:			    ; Label.
	stc					    ; Error :(.
	ret					    ; Return.

writeCommandNameErrorFat16ABC:			    ; Label.
	stc					    ; Error :(.                   
	ret					    ; Return.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; HddFat16WriteFolder.                                                             ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
HddFat16WriteFolder:				    ; Name of function.
	mov   eax,FolderNameC			    ; Get address of folder
	mov   [FolderNameWriteFat16],eax	    ; Store it.
	mov   eax,dword[FileSizeInBytesFat16]	    ; Load eax with file size
	call  GetFileSizeInClusters		    ; Convert file size from bytes, to number of clusters.
	call  UsedSectorsFat16Write		    ; We need to see if theres any space on the hdd.
	mov   [ErrorCodeFat16],5		    ; Put the right error code in error var, for next bit.
	mov   eax,dword[FreeClustersFat16]	    ; We need to move nunber of free clusters into a reg, as memory to memory is not possable
	cmp   [FileSizeInClustersFat16],eax	    ; Can we fit the file on the Hdd ?.
	ja    writeCommandErrorFat16AB		    ; If not end with error.
	mov   [ErrorCodeFat16],0		    ; Put the right error code in error var, for next bit.
	call  FindNextFreeFolderEntryFat16	    ; Need to find a free root entry.
	jc    writeCommandErrorFat16AB		    ; If we have a error jump exit, set error flag.
	mov   esi,dword[NameOfFileToMakeFat16]	    ; We need the address of file towrite for next function, in esi.
	mov   [RootDirBufferVarC],0x110000	    ; Make sure its using the the dirs buffer.
	call  MakeNewFileFat16			    ; Call function.
	jc    writeCommandErrorFat16AB		    ; If we have a error jump exit, set error flag.
	mov   edi,RootDirBufferHdd		    ; Load root buffer into edi.
	mov   [RootDirBufferVarC],edi		    ; Store it.
	call  FillOutRootEntryFAT16		    ; Put name of file in root dir entry.
	call  UpdateClusterChainHddFat16	    ; Up date FAT.
	jc    writeCommandErrorFat16AB		    ; If we have a error jump exit, set error flag.
	call  WriteFat16			    ; Write file to Hdd
	mov   dword[HddSectorsWriteCountFat16],ebx  ; EBX is returned with number of sector wrote to hdd.
	jc    writeCommandErrorFat16AB		    ; If we have a error jump exit, set error flag.
	call  DirFatRootUpdateFat16		    ; If not errors write new root and fat to hdd.
	jc    writeCommandErrorFat16AB		    ; If we have a error jump exit, set error flag.
	mov   ax,[FirstFolderClusterA]		     ; Put the folders cluster in AX
	mov   [FileCluster],ax			    ; Put AX into the FileCluster var
	mov   [LoadFileFromAddressFat16],0x110000   ; Uses the folders dir buffer.
	call  WriteFat16			    ; Write file to Hdd
	jc    writeCommandErrorFat16AB		    ; If we have a error jump exit, set error flag.
	clc					    ; No errors :).
	ret					    ; Return.

writeCommandErrorFat16AB:			    ; Label.
	stc					    ; Error :(.
	ret					    ; Return.

writeCommandNameErrorFat16AB:			    ; Label.
	stc					    ; Error :(.                   
	ret					    ; Return.

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; GetFileSizeInClusters.                                                           ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
GetFileSizeInClusters:				    ; Name of function.
	pushad					    ; Save 32bit general registers.
	push  es				    ; Save ES.
	push  ds				    ; Save DS.
	push  eax				    ; Save whats in EAX, on stack.
	mov   ax,18h				    ; Move data descriptors into AX.
	mov   ds,ax				    ; Now add AX to DS (NO direct segment reg addressing).       
	mov   es,ax				    ; Now add AX to eS (NO direct segment reg addressing).       
	pop   eax				    ; Restore EAX.
	mov   dword[FileSizeInSectorsFat16],eax     ; EAX should have size of file to write in bytes.
	cmp   dword[FileSizeInSectorsFat16],511     ; Check if it only 1 sector, in size.
	ja    @f				    ; If jump if it bigger.
	mov   [FileSizeInSectorsFat16],1	    ; Only 1 sector.
	jmp   JustOneCluster			    ; Exit file is only 1 cluster in size.
@@:						    ; Label.
	xor   edx,edx				    ; Make sure edx is 0.
	mov   eax,dword[FileSizeInSectorsFat16]     ; Move file size into EAX (size is still in bytes).
	mov   ecx,512				    ; Move sector size, (hard coded as 512b).
	div   ecx				    ; Div EAX and ECX.
	mov   dword[FileSizeInSectorsFat16],eax     ; Store result 'FileSizeInSectors' var.
	cmp   edx,0				    ; Check any remainders ?.
	je    ExitFileSizeInSectorsFat16	    ; Jump over next bit if not.
	inc   [FileSizeInSectorsFat16]		    ; If remainder add 1 to 'FileSizeInSectors' var.
ExitFileSizeInSectorsFat16:			    ; Label.
	xor   edx,edx				    ; Make sure edx is 0.
	xor   ebx,ebx				    ; Make sure ebx is 0.
	mov   bl,[bpbSectorsPerCluster1]	    ; Load the number of sectors per cluster into bl.
	cmp   [FileSizeInSectorsFat16],ebx	    ; Compare files size with 'SectorsPerCluster'
	jbe   JustOneCluster			    ; If below, then only need to write 1 clusters. 
	xor   edx,edx				    ; Make sure edx is 0.
	mov   eax,[FileSizeInSectorsFat16]	    ; Move file size into EAX (size is still in bytes).
	mov   ecx,ebx				    ; EBX, should still hold number of sectors per cluster,move it into ECX.
	div   ecx				    ; Div  EAX and ECX.
	mov   [FileSizeInClustersFat16],eax	    ; Store result 'FileSizeInClusters' var.
	cmp   edx,0				    ; Check any remainders ?.
	je    @f				    ; Jump over next bit if not.
	inc   [FileSizeInClustersFat16] 	    ; If remainder add 1 to 'FileSizeInClusters' var.
@@:						    ; Label.
	pop   ds				    ; Restore DS.
	pop   es				    ; Restore ES.
	popad					    ; Restore 32bit general registers.
	ret					    ; Return.

JustOneCluster: 				    ; Label.
	mov   [FileSizeInClustersFat16],1	    ; File is only 1 cluster in size, put 1 'FileSizeInClusters' var.
	pop   ds				    ; Restore DS.
	pop   es				    ; Restore ES.
	popad					    ; Restore 32bit general registers.
	ret					    ; Return.

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; UsedSectorsFat16Write.                                                           ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
UsedSectorsFat16Write:				    ; Name of function.
	pushad					    ; Save 32bit general registers.                 
	push  es				    ; Save ES.
	push  ds				    ; Save DS.
	mov   ax,18h				    ; Move data descriptors into AX.
	mov   ds,ax				    ; Now add AX to DS (NO direct segment reg addressing).       
	mov   es,ax				    ; Now add AX to ES (NO direct segment reg addressing).       
	mov   [FreeSectorsFat16],0		    ; Make sure the var is 0.
	mov   [UsedClusterCountFat16],0 	    ; Make sure the var is 0.
	xor   ecx,ecx				    ; Make sure ecx is 0.
	xor   edx,edx				    ; Make sure edx is 0.
	xor   eax,eax				    ; Make sure eax is 0.
	mov   ax,[bpbTotalSectors1]		    ; We check if 'bpbTotalSectors'is used.
	cmp   ax,0				    ; Is it 0 ?.
	jnz   @f				    ; If not it's used, so jump over next bit.
	mov   eax,[bpbTotalSectorsBig1] 	    ; We need to use 'bpbTotalSectorsBig' instead.
@@:						    ; Label.
	mov   dx,[DataStartFat16]		    ; The var has the start address of Data area in it.
	sub   eax,edx				    ; Take the used sector from total sectors
	xor   edx,edx				    ; Make sure edx is 0.
	mov   cl,[bpbSectorsPerCluster1]	    ; Move number of sectors per cluster into CL.                 
	div   ecx				    ; DIV eax and ecx
	cmp   dx,0				    ; Check for any remainders
	je    @f				    ; No jump to label
	inc   eax				    ; If we have remainders add 1 to eax.
@@:						    ; Label.
	mov   cx,ax				    ; Move ax into cx for loop count.
	mov   word[DataSizeInClusters],ax	    ; Also store it for later.
	mov   esi,FatHdd			    ; Put address of FAT in esi
	add   esi,4				    ; Add 4 as, we start from cluster 3 (2bytes per cluster, 4 + 2 clusters).
UsedSectorsLoopFat16:				    ; Label.
	lodsw					    ; load a word into AX.
	cmp   ax,0x0000 			    ; Check for free cluster.
	je    @f				    ; If so jump to label.
	inc   [UsedClusterCountFat16]		    ; Not 0, then inc used count.
@@:						    ; Label.
	loop  UsedSectorsLoopFat16		    ; CX not 0 loop again.
	mov   ax,word[DataSizeInClusters]	    ; Load data area size into AX.
	sub   ax,[UsedClusterCountFat16]	    ; Take away used clusters.
	mov   [FreeClusterCountFat16],ax	    ; Save number of free clusters.
	xor   eax,eax				    ; Make sure eax is 0.
	mov   ecx,eax				    ; Make sure ecx is 0.
	mov   edx,eax				    ; Make sure edx is 0.
	mov   ax,[FreeClusterCountFat16]	    ; Move number of free clusters into AX.
	mov   cl,[bpbSectorsPerCluster1]	    ; Move number of sectors clusters into CL.
	mul   ecx				    ; MUL EAX and ECX.
	mov   [FreeSectorsFat16],eax		    ; Save results in var
	xor   eax,eax				    ; Make sure eax is 0.
	mov   ax,[FreeClusterCountFat16]	    ; Mov free clusters number into AX.
	mov   [FreeClustersFat16],eax		    ; Pack free clusters number size from 16bit to 32bit and save.
	pop   ds				    ; Restore DS.
	pop   es				    ; Restore ES.
	popad					    ; Restore 32bit general registers.
	ret					    ; Return.

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; FindNextFreeRootEntryFat16                                                       ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
FindNextFreeRootEntryFat16:			    ; Name of function.
	pushad					    ; Save 32bit general registers.
	push  es				    ; Save ES.
	mov   ax,18h				    ; Move data descriptors into AX.       
	mov   es,ax				    ; Now add AX to ES (NO direct segment reg addressing).       
	mov   edi,[RootDirBufferVarC]		    ; Get the root buffer address.
	mov   dx,0x1000 			    ; Set loop number to max for Fat16.
FindNextFreeRootEntryLoopHddFat16:		    ; Label.
	cmp   byte[es:edi],byte 0		    ; Test for a emtpy root entry.
	je    FoundSpaceInRootdirHddFat16	    ; Is it emtpy ?
	cmp   byte[es:edi],0xe5 		    ; Test for deleted file
	je    FoundSpaceInRootdirHddFat16	    ; If so we can use it.
	add   edi, 32				    ; Try the next entry.
	dec   dx				    ; Take 1 from loop number var.
	jnz   FindNextFreeRootEntryLoopHddFat16     ; If more to check then loop.
	jmp   FindNextFreeRootEntryErrorHddFat16    ; No more end with error.
FoundSpaceInRootdirHddFat16:			    ; Label.
	mov   dword[RootDirEntryAddressFat16],edi   ; Save the free root entry address.
FindNextFreeRootEntrySucsessHddFat16:		    ; Label.
	pop   es				    ; Restore ES.
	popad					    ; Restore 32bit general registers.
	clc					    ; No errors :).
	ret					    ; Return.

FindNextFreeRootEntryErrorHddFat16:		    ; Label.
	mov   [ErrorCodeFat16],3		    ; Error so set right error number.
	pop   es				    ; Restore ES.
	popad					    ; Restore 32bit general registers.
	stc					    ; Errors :(.
	ret					    ; Return.

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; FindNextFreeRootEntryFat16                                                       ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
MakeNewFileFat16:				    ; Name of function.
	pushad					    ; Save 32bit general registers.
	push  es				    ; Save ES.
	push  ds				    ; Save DS.
	call  FindFileNameFat16 		    ; Check for file of same name.
	jnc   CheckForSameNameFoundHddFat16	    ; Is there a file same name ?.
CheckForSameNameNotFoundHddFat16:		    ; Label.
	mov   edi,FileEntry			    ; We need to set a root entry out.
	mov   esi,NameOfFileToLoadBufferFat16	    ; First name of file.
	mov   cx,11				    ; Number of letters 8+3
	rep   movsb				    ; move from a to b.
	call  GetNextClusterHddFat16		    ; Get the next free cluster for next bit.
	jc    CheckForSameNameFoundHddFat16	    ; Jump error exit if no free clusters.
	mov   edi,FileCluster			    ; Point it to the cluster address.
	mov   ax,[ClusterCount] 		    ; Move next free cluster number into AX
	mov   word [StartCluster],ax		    ; Move AX into start cluster var.
	stosw					    ; Move next free cluster into 'FileCluster'
	mov   edi,FileAttr
	mov   al,[FileAttrFat16]
	stosb
	mov   edi,FileSize			    ; Get file size address
	mov   eax,dword[FileSizeInBytesFat16]	    ; Move file size in bytes into eax
	stosd					    ; Set file size in root entry.
	call  FloppyTime			    ; Call time stamp function.
	mov   ax,[FddTime]			    ; Put time stamp in AX.
	mov   edi,FileTime			    ; Put address of filetime into edi.
	stosw					    ; Move whats in AX to address edi points to.
	call  FloppyDate			    ; Call Date stamp function.
	mov   ax,[FddDate]			    ; Put Date stamp in AX.
	mov   edi,FileDate			    ; Put address of fileDate into edi.
	stosw					    ; Move whats in AX to address edi points to.
	pop   ds				    ; Restore DS.
	pop   es				    ; Restore ES.
	popad					    ; Restore 32bit general registers.
	clc					    ; No errors :).
	ret					    ; Return.

CheckForSameNameFoundHddFat16:			    ; Label.
	pop   ds				    ; Restore DS.
	pop   es				    ; Restore ES.
	popad					    ; Restore 32bit general registers.
	mov   [ErrorCodeFat16],4		    ; Error so set right error number.
	stc					    ; Errors :(.
	ret					    ; Return.

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; FindNextFreeRootEntryFat16                                                       ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
FindFileNameFat16:				    ; Name of function.
	pushad					    ; Save 32bit general registers.
	mov   dword[RootFileAddressFat16],0	    ; Make sure the var is 0.
	mov   dword[NameOfFileToLoadFat16],esi	    ; Save name of file to write.
	call  ConvertFileNameFat16		    ; Convert name for uses in root entry.
	mov   edi,NameOfFileToLoadBufferFat16	    ; Converted name should be here.
	call  UpperCaseFat16			    ; Convert name to upper case.
	mov   edi,[RootDirBufferVarC]		    ; Move root buffer address into edi
	mov   esi,NameOfFileToLoadBufferFat16	    ; Move name buffer address into esi.
	mov   dx,[bpbRootEntries1]		    ; Number of root dir entrys, load in to DX.
	cmp   [RootYesNoC],0 
	je    CheckForSameNameHddFat16
	mov   dx,[FolderEntrysNumber]
CheckForSameNameHddFat16:			    ; Label.      
	mov  ecx,11				    ; Number of loops
CheckForSameNameLoopHddFat16:			    ; Label.    
	cmp   byte [es:edi],ch			    ; Check for no more entrys.
	je    CheckForSameNameNotFoundinRootDirHddFat16  ; If so exit.                         
	pushad					    ; Save 32bit general registers.               
	repe  cmpsb				    ; Compare them.
	popad					    ; Restore 32bit general registers.                         
	je    CheckForSameNameFoundinRootDirHddFat16  ; Jume = to found file same name label
	add   edi, 32				    ; If not try the next root entry.
	dec   dx				    ; Sub 1 off loop count.
	jnz   CheckForSameNameLoopHddFat16	    ; If 0 end.
CheckForSameNameNotFoundinRootDirHddFat16:	    ; Label.      
	popad					    ; Restore 32bit general registers.
	stc					    ; Errors :(, but we want that here :).
	ret					    ; Return.

CheckForSameNameFoundinRootDirHddFat16: 	    ; Label.    
	mov   dword[RootFileAddressFat16],edi	    ; Store the address in root entry, file by same name.
	popad					    ; Restore 32bit general registers.
	clc					    ; No errors :), but we want that here :(.
	ret					    ; Return.

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; ConvertFileNameFat16.                                                            ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ConvertFileNameFat16:				    ; Name of function.
	pushad					    ; Save 32bit general registers.
	mov   esi,[NameOfFileToLoadFat16]	    ; Move name of file to convert.
	mov   edi,NameOfFileToLoadBufferFat16	    ; Buffer address used for converting.
	mov   ecx,8				     ; Number of letters
ConvertCliFileNameUFat16:			    ; Label.  
	cmp   byte [ds:esi],'.' 		    ; Check a .
	je    @f				    ; Jump = to label.
	cld					    ; Set left to right.
	movsb					    ; Move a byte.
	dec   ecx				     ; dec count.
	jnz  ConvertCliFileNameUFat16		    ; If not 0 do another loop.
	jmp   FinConertCliFnameUFat16		    ; If 0 jump label
@@:						    ; Label.  
	mov   al,0x20				    ; Put a space code in al.
	cld					    ; Set left to right.
	rep   stosb				    ; loop till cx is 0
FinConertCliFnameUFat16:			    ; Label. 
	cmp   byte [ds:esi],'.' 		    ; Check a . ( have not been here before).
	jne   @f				    ; Not = jump other next bit.
	inc   esi				    ; Inc the pointer
@@:						    ; Label. 
	mov   ecx,3				     ; Number of Ext
	cld					    ; Set left to right.
	rep   movsb				    ; Move from a to b.
	mov   al,0				    ; We need a 0 at end of name.
	stosb					    ; So let put one there.
	popad					    ; Restore 32bit general registers.
	ret					    ; Return.

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; ConvertFileNameFat16.                                                            ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
UpperCaseFat16: 				    ; Name of function.
	pushad					    ; Save 32bit general registers.
	push  es				    ; Save ES.
	mov   ax,18h				    ; Move data descriptors into AX.            
	mov   es,ax				    ; Now add AX to ES (NO direct segment reg addressing).       
UcaseNextCharFat16:				    ; Label. 
	mov   al,byte[es:edi]			    ; Move the first letter.
	cmp   al,0				    ; Is it 0
	je    UcaseDoneFat16			    ; If yes, then we are done.
	cmp   al,0x61				    ; Test being below 0x61
	jb    DontUcaseCharFat16		    ; If so do another loop
	cmp   al,0x7a				    ; Test for above 0x7a
	ja    DontUcaseCharFat16		    ; If so do another loop
	sub   al,0x20				    ; If not take 0x20 off number
	mov   byte[es:edi],al			    ; Put it back modithed 
DontUcaseCharFat16:				    ; Label. 
	inc   edi				    ; inc the pointer
	jmp   UcaseNextCharFat16		    ; Ant try next char.
UcaseDoneFat16: 				    ; Label. 
	pop   es				    ; Restore ES.
	popad					    ; Restore 32bit general registers.
	ret					    ; Return.

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; FillOutRootEntryFAT16                                                            ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
FillOutRootEntryFAT16:				    ; Name of function.
       pushad					    ; Save 32bit general registers.
       push  es 				    ; Save ES.
       push  ds 				    ; Save ES.
       mov   ax,18h				    ; Move data descriptors into AX.
       mov   ds,ax				    ; Now add AX to DS (NO direct segment reg addressing).            
       mov   es,ax				    ; Now add AX to ES (NO direct segment reg addressing).       
       mov   edi,[RootDirEntryAddressFat16]	    ; Get the destanation address in edi.
       mov   esi,FileEntry			    ; Get the source address in esi.
       mov   ecx,8				     ; Get number of letters.
       rep   movsd				    ; Move from A to B.
       pop   ds 				    ; Restore DS.
       pop   es 				    ; Restore ES.
       popad					    ; Restore 32bit general registers.
       ret					    ; Return.

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; UpdateClusterChainHddFat16.                                                      ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
UpdateClusterChainHddFat16:			    ; Name of function.
	pushad					    ; Save 32bit general registers.
	push  es				    ; Save ES.
	push  ds				    ; Save DS.
	mov   ax,18h				    ; Move data descriptors into AX.
	mov   ds,ax				    ; Now add AX to DS (NO direct segment reg addressing).    
	mov   es,ax				    ; Now add AX to eS (NO direct segment reg addressing).   
	mov   ax,[FileCluster]			    ; Get start cluster.
	cmp   [FileSizeInClustersFat16],1	    ; Test if we only need 1 cluster.
	jbe   EndOfFileHddFat16 		    ; If so jump to exit and mark end cluster.
	mov   ecx,dword[FileSizeInClustersFat16]    ; If not get hoe many clusters we need.
	dec   ecx				    ; Sub 1 from number.
@@:						    ; Label.
	push  ecx				    ; Save number of cluster for latter.
	call  GetNextTwoClustersHddFat16	    ; Find the next two free clusters.
	jc    UpdateClusterChainErrorHddFat16	    ; If we have a error jump exit, set error flag eg: no free cluster..
	mov   ax,[ClusterOne]			    ; Save cluster A.
	mov   bx,[ClusterTwo]			    ; Save cluster B.
	call  UpdateClusterValueHddFat16	    ; Up date FAT.
	pop   ecx				    ; Get saved 'number of cluster'.
	loop  @b				    ; Not 0 do another loop.
	mov   ax,[ClusterTwo]			    ; Save the sccond to lest cluster.
EndOfFileHddFat16:				    ; Label.
	mov   bx,0xffff 			    ; Put the last cluster mark in BX.
	call  UpdateClusterValueHddFat16	    ; Write them to fat.
	pop   ds				    ; Restore DS.
	pop   es				    ; Restore ES.
	popad					    ; Restore 32bit general registers.
	clc					    ; No errors :).
	ret					    ; Return.

UpdateClusterChainErrorHddFat16:		    ; Label.
	pop   ds				    ; Restore DS.
	pop   es				    ; Restore eS.
	popad					    ; Restore 32bit general registers.
	stc					    ; Errors :(.
	ret					    ; Return.

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; GetNextTwoClustersHddFat16.                                                      ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
GetNextTwoClustersHddFat16:			    ; Name of function.
	pushad					    ; Save 32bit general registers.
	mov   ax,word[DataSizeInClusters]	    ; Get data area size inclusters.
	mov   [MaxClusters],ax			    ; Put it in MaxCluster var.
	mov   esi,FatHdd			    ; Get address of FAT
	add   esi,4				    ; Jump other fist 2 clusters.
	mov   [ClusterCount],2			    ; set some vars
	mov   [Clusterloop],0			    ; Make sure the var is 0
	mov   cx,[MaxClusters]			    ; Set the number of loops.      
GetNextTwoClusterLoopHddFat16:			    ; Label.
	lodsw					    ; Load the first cluster.
	and   ax,0xFFFF 			    ; Check for 0.
	jz    FoundFreeClusterTwoAHddFat16	    ; If its free jump to save address.
GetNextFreeCluster16:				    ; Label.
	inc   [ClusterCount]			    ; If not inc address.
	loop  GetNextTwoClusterLoopHddFat16	    ; Not 0 loop.
	mov   [ErrorCodeFat16],5		    ; If we end up here, we have a run out of clusters error.
	popad					    ; Restore 32bit general registers.
	stc					    ; Error :(.
	ret					    ; Return.

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; FoundFreeClusterTwoAFat16                                                        ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
FoundFreeClusterTwoAHddFat16:			    ; Name of function.
	cmp   [Clusterloop],1			    ; Is this the first time we have come here?.
	je    @f				    ; Label.
	mov   ax,[ClusterCount] 		    ; Get the cluster address
	mov   [ClusterOne],ax			    ; Save it for latter.
	mov   [Clusterloop],1			    ; Mark we have been here before.
	;inc   [ClusterCount]                       ; Inc the count now instead of later.
	jmp   GetNextFreeCluster16		    ; Jump back to get one more cluster address.       
@@:						    ; Label.
	mov   ax,[ClusterCount] 		    ; Move cluster address into AX
	mov   [ClusterTwo],ax			    ; Put it in the second of the two clusters.
	popad					    ; Restore 32bit general registers.
	clc					    ; No Errors :).
	ret					    ; Return.

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; UpdateClusterValueHddFat16.                                                      ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
UpdateClusterValueHddFat16:			    ; Name of function.
	pushad					    ; Save 32bit general registers.
	mov   word[Cluster],ax			    ; Address of cluster                 
	mov   word[UpdateValue],bx		    ; Up date value. 
	xor   ecx,ecx				    ; Make sure top half of ecx is emptpy
	mov   cx,ax				    ; Mveve the address into cx.
	shl   cx,1				    ; Mul by 2.           
	mov   esi,FatHdd			    ; Load address of FAT.                        
	add   esi,ecx				    ; Add offset to fat, to get cluster address.
	mov   dx,word [ds:esi]			    ; Get what's at that address.
	mov   [ClustOrigValue],dx		    ; Save it.  
	mov   word [ds:esi],bx			    ; Put the new value.        
DoneUpdateClusterValueHddFat16: 		    ; Label.
	popad					    ; Restore 32bit general registers.
	ret					    ; Return.

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; WriteFat16.                                                                      ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
WriteFat16:					    ; Name of function.
	pushad					    ; Save 32bit general registers.         
	push  es				    ; Save ES.
	push  ds				    ; Save DS.
	mov   [HddFileName],edi 		    ; Store name of file.
	mov   [FileLoadAddress],edx		    ; 0x200000
	mov   esi,[LoadFileFromAddressFat16]	    ; Address of file to write, put in esi
	mov   [FileLoadAddress],esi		    ; Move whats in esi into the right var. 
	mov   [FileLoadCount],0 		    ; 0 file load count,adds 512bytes to load address
	mov   [FddSectorsLoadedCount],0 	    ; 0 file number of sectors load count.
	xor   ecx,ecx				    ; 0 ecx
	mov   ax,[bpbRootEntries1]		    ; Move value to register to work on. ax=Arithmatic
	mov   cx, 32				    ; Move value to multiply into register
	mul   cx				    ; Multiply
	div   word [bpbBytesPerSector1] 	    ; Divide
	mov   [RootSize],ax			    ; Put the value into a nice storage area for a bit
	mov   dx,ax				    ; Put root size in DX.
	xor   ax,ax				    ; 0 AX
	mov   al, byte [bpbNumberOfFATs1]	    ; Load up number of FAT tables (/info) into AL
	mul   word[bpbSectorsPerFAT1]		    ; Multiply AL by the number of sectors per FAT table (/info)
	add   ax,word[FatStartFat16]		    ; Add to the FAT total (AX) the number of reserved sectors
	mov   [RootStart],ax			    ; Put the start of the root address into RootStart variable
	mov   [RootStartDx],dx			    ; Keep this we may need it.
	mov   cx,[RootSize]			    ; Mov the root size into CX
	add   ax,cx				    ; Add ax (RootStart) to cx (RootSize)
	mov   [DataStart],ax			    ; Move the answer into DataStart
	mov   ax,18h				    ; Move how data base,into ax
	mov   es,ax				    ; Now add AX to ES (NO direct segment reg addressing).    
	mov   ds,ax				    ; Now add AX to DS (NO direct segment reg addressing).    
	mov   edi,[RootDirBufferVarC]		    ; Where we are loading to.
	mov   esi,[HddFileName] 		    ; RootConvertedFileName
	mov   dx,[bpbRootEntries1]		    ; Move number of root entrys into count.
	mov   dx,[FileCluster]			    ; Get start cluster.
	mov   word [cluster],dx 		    ; files first cluster.
LoadImageWriteFat16:				    ; Label.
	mov   ax,[cluster]			    ; mov cluster address, into ax
	mov   [FloppyTestFat16],0		    ; need to try to read floppy aleast 3 times
WriteNextClusterFat16:				    ; useally has more that one sector per cluster.
	call  ClusterLBAFat16			    ; Convert cluster to LBA
	mov   [clusterSPC],ax			    ; Save it, so we can inc it on loop.
	xor   ecx,ecx				    ; Clear ecx
	mov   cl,byte [bpbSectorsPerCluster1]	    ; Mov sectors per cluster in to cx, as fat16/32-
ReadNextClusterWriteFat16loop:			    ; Label.
	push  ecx				    ; Save number of loops
	mov   [FloppyTestFat16],0		    ; Set number of retrys to 0
	call  WriteSectorsFat16 		    ; Write sector
	jc    ErrorFloppyPopHddFat16		    ; jmp if error
	inc   [clusterSPC]			    ; inc, for next sector.                
	mov   ax,[clusterSPC]			    ; move it to AX
	pop   ecx				    ; Unsave loop number.
	loop  ReadNextClusterWriteFat16loop	    ; Not 0, then loop.
	xor   ecx,ecx				    ; Make sure reg is 0.
	xor   eax,eax				    ; Make sure reg is 0.
	mov   ax,word[cluster]			    ; identify current cluster
	mov   cx,ax				    ; copy current cluster
	add   ecx,eax				    ; Time the cluster number by 2, use 32bit regs.
	mov   esi,FatHdd			    ; location of FAT in memory
	add   esi,ecx				    ; index into FAT
	mov   dx,word [ds:esi]			    ; read two bytes from FAT
	mov   word [cluster],dx 		    ; store new cluster
	cmp   dx,0xFFF0 			    ; test for end of file (maybe 0FFF8h ?)
	jb    LoadImageWriteFat16		    ; If not do another loop.
ExitSucsessWriteFat16:				    ; Label.
	pop   ds				    ; Restore DS
	pop   es				    ; Restore ES
	popad					    ; Restore 32bit general registers.
	mov   ebx,[FddSectorsLoadedCount]	    ; Put number of bytes written in ebx.
	clc					    ; No errors :).
	ret					    ; Return.
      
ErrorFindFat16: 				    ; Label.
	pop   ds				    ; Restore DS
	pop   es				    ; Restore ES
	popad					    ; Restore 32bit general registers.
	stc					    ; Set error :(.
	ret					    ; Return.

ErrorFloppyPopHddFat16: 			    ; Label.
	pop   ecx				    ; Restore ECX
ErrorFloppyHddFat16:				    ; Label.
	pop   ds				    ; Restore DS
	pop   es				    ; Restore ES
	popad					    ; Restore 32bit general registers.
	stc					    ; Set error :(.
	ret					    ; Return.

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; WriteSectorsFat16.                                                               ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
WriteSectorsFat16:				    ; Name of function.
	pushad					    ; Save 32bit general registers.  
	push  ds				    ; Save DS.
	push  es				    ; Save ES.
	call  LBAcHsFat16			    ; Call function.
	mov   esi,[FileLoadAddress]		    ; Load address of file to write.  
	add   esi,[FileLoadCount]		    ; Add add on.
	add   [FileLoadCount],512		    ; Add 512 bytes more to add on.
	add   [FddSectorsLoadedCount],1 	    ; Add 1 to number of sector written.
TryWriteHddFat16FloppyAgain:			    ; Label.
	mov   ch,byte [absoluteTrackFat16]	    ; track.
	mov   cl,byte [absoluteSectorFat16]	    ; sector.
	mov   dh,byte [absoluteHeadFat16]	    ; head.
	mov   dl,80h ;byte [bsDriveNumber]          ; drive.
	call  HddWriteFat16			    ; Write sector to Hdd.             
	jc    @f				    ; Jump errors .
HddFat16WriteOK:				    ; Label.
	pop   es				    ; Restore ES
	pop   ds				    ; Restore DS
	popad					    ; Restore 32bit general registers.
	clc					    ; No errors :).
	ret					    ; Return.

@@:						    ; Label.
	pop   es				    ; Restore ES
	pop   ds				    ; Restore DS
	popad					    ; Restore 32bit general registers.
	stc					    ; Error :(.
	ret					    ; Return.

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; DirFatRootUpdateFat16                                                            ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
DirFatRootUpdateFat16:				   ; Name of function.
	pushad					   ; Save 32bit general registers.
DirWriteFillRootHddUSB: 			   ; Label.
	mov   ax,word[bpbHiddenSectors1]	   ; Get Hidden Sectors.
	mov   dx,word[bpbHiddenSectors1+2]	   ; Get Hidden Sectors +.
	add   ax,word [bpbReservedSectors1]	   ; Add Reserved Sectors to Hidden Sectors.
	mov   [FatStartDxFat16],dx		   ; Save Hidden Sectors +.
	mov   [FatStartFat16],ax		   ; Save Reserved Sectors + Hidden Sectors.
	xor   eax,eax				   ; 0 eax.
	mov   ecx,eax				   ; 0 ecx.     
	mov   al, byte [bpbNumberOfFATs1]	   ; Get number of fats.                
	mul   word [bpbSectorsPerFAT1]		   ; Mul with Sectors Per FAT.
	mov   [FatSize2Fat16],ax		   ; Save result.
	xor   eax,eax				   ; 0 eax.
	mov   ax,word [bpbSectorsPerFAT1]	   ; Get Sectors Per FAT.
	mov   [FatSize1Fat16],ax		   ; Save it
	mov   ax,[bpbRootEntries1]		   ; Get root entrys          
	mov   cx, 32				   ; Move CX 32               
	mul   cx				   ; Mul number of root entrys by 32.            
	div   word [bpbBytesPerSector1] 	   ; Div result by Bytes Per Sector.       
	mov   [RootSizeFat16],ax		   ; Save results.       
	xor   eax,eax				   ; 0 eax.                     
	mov   edx,eax				   ; 0 edx.
	mov   al, byte [bpbNumberOfFATs1]	   ; Get number of fats.         
	mul   word [bpbSectorsPerFAT1]		   ; Mul with Sectors Per FAT.          
	add   ax, [FatStartFat16]		   ; Add fat start.
	mov   [RootStartDxFat16],dx		   ; Save any left over.    
	mov   [RootStartFat16],ax		   ; Save results of above mul + fat start address in var.                      
	mov   cx,[RootSizeFat16]		   ; Get root size                     
	add   ax,cx				   ; Add it to AX.          
	mov   [DataStartFat16],ax		   ; Save as data start address.
	mov   [FloppyTestFat16],0		   ; 0 Write Hdd error var.
	mov   [FileLoadCount] ,0		   ; 0 File Load Count var.
	mov   [FddSectorsLoadedCount],0 	   ; 0 Sectors Loaded Count var
	mov   edi,FatHdd			   ; Get FAT address.
	mov   [FileLoadAddress],edi		   ; Save it.
	xor   eax,eax				   ; 0 eax.  
	mov   ecx,eax				   ; 0 ecx.  
	mov   dx,[FatStartDxFat16]		   ; Get Fat Start +.
	mov   ax,[FatStartFat16]		   ; Get Fat Start.
	mov   cx,[FatSize1Fat16]		   ; Get Fat Size.
WriteSectorsLoopUSB1:				   ; Label.
	mov   [FloppyTestFat16],0		   ; 0 Write Hdd error var.
	call  WriteSectorsFat16 		   ; Write a sector to Hdd.
	jc    DirErrorUSBWrite			   ; Jump if error.
	inc   ax				   ; Next sector.
	loop  WriteSectorsLoopUSB1		   ; Loop if cx not 0.
	cmp   [RootYesNoC],0			   ; Check if we are writing to root dir.
	jne   DirWriteFillRootUSBSuccsess	   ; Miss next bit if we are.
	mov   [FloppyTestFat16],0		   ; 0 Write Hdd error var.
	mov   [FileLoadCount],0 		   ; 0 File Load Count var.
	mov   [FddSectorsLoadedCount],0 	   ; 0 Sector Write Count var.
	mov   edi,[RootDirBufferVarC]		   ; Get address of root buffer.
	mov   [FileLoadAddress],edi		   ; Save it.
	xor   eax,eax				   ; 0 eax. 
	mov   dx,[RootStartDxFat16]		   ; Get Fat Start +.
	mov   ax,[RootStartFat16]		   ; Get Fat Start.
	mov   cx,[RootSizeFat16]		   ; Get Fat Size.
WriteSectorsLoopUSB2:				   ; Label.
	mov   [FloppyTestFat16],0		   ; 0 Write Hdd error var.
	call  WriteSectorsFat16 		   ; Write a sector to Hdd.
	jc    DirErrorUSBWrite			   ; Jump if error.
	inc   ax				   ; Next sector.
	loop  WriteSectorsLoopUSB2		   ; Loop if cx not 0.
DirWriteFillRootUSBSuccsess:			   ; Label.
	popad					   ; Restore 32bit general registers.
	clc					   ; No errors :).
	ret					   ; Return.             

DirErrorUSBWrite:				   ; Label.
	popad					   ; Restore 32bit general registers.  
	stc					   ; Error :(.
	ret					   ; Return.

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; GetNextClusterHddFat16.                                                          ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
GetNextClusterHddFat16: 			  ; Name of function.
	pushad					  ; Save 32bit general registers.
	mov   ax,word[DataSizeInClusters]	  ; Get data size in clusters.
	mov   [MaxClusters],ax			  ; Save it as Max number of clusters.
	mov   esi,FatHdd			  ; Get fat address.
	add   esi,4				  ; Add 4 to address.
	mov   [ClusterCount],2			  ; Add first 2 clusters to count var.
	mov   cx,[MaxClusters]			  ; Get max number of loops                            
GetNextClusterLoopHddFat16:			  ; Label.
	lodsw					  ; Load a word from fat address.
	and   ax,0xFFFF 			  ; Check for 0.
	jz    FoundFreeClusterHddFat16		  ; If 0 we have found a free cluster.
	inc   [ClusterCount]			  ; If not inc count
	loop  GetNextClusterLoopHddFat16	  ; And loop if cx not 0.
	popad					  ; Restore 32bit general registers. 
	stc					  ; Error, run out of free clusters.
	ret					  ; Return.

FoundFreeClusterHddFat16:			  ; Label.
	popad					  ; Restore 32bit general registers. 
	clc					  ; No errors :).
	ret					  ; Return.
;2


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; FindNextFreeFolderEntryFat16                                                     ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
FindNextFreeFolderEntryFat16:			    ; Name of function.
	pushad					    ; Save 32bit general registers.
	push  es				    ; Save ES.
	mov   ax,18h				    ; Move data descriptors into AX.       
	mov   es,ax				    ; Now add AX to ES (NO direct segment reg addressing).       
	mov   edi,0x110000			    ; Get the root buffer address.
	mov   eax,dword[FolderSizeSectors]	    ; Get folder dir size in sectors
	shl   eax,9				    ; Mul by 512
	shr   eax,5				    ; Convert it to number of 32 bytes.
	mov   [FolderEntrysNumber],ax		    ; Save it.
	mov   dx,[FolderEntrysNumber]		    ; Set loop number to max for Fat16.
FindNextFreeFolderEntryLoopHddFat16:		    ; Label.
	cmp   byte[es:edi],byte 0		    ; Test for a emtpy root entry.
	je    FoundSpaceInFolderdirHddFat16	    ; Is it emtpy ?
	cmp   byte[es:edi],0xe5 		    ; Test for deleted file
	je    FoundSpaceInFolderdirHddFat16	    ; If so we can use it.
	add   edi, 32				    ; Try the next entry.
	dec   dx				    ; Take 1 from loop number var.
	jnz   FindNextFreeFolderEntryLoopHddFat16   ; If more to check then loop.
	jmp   FindNextFreeFolderEntryErrorHddFat16  ; No more end with error.
FoundSpaceInFolderdirHddFat16:			    ; Label.
	mov   dword[RootDirEntryAddressFat16],edi   ; Save the free root entry address.
FindNextFreeFolderEntrySucsessHddFat16: 	    ; Label.
	pop   es				    ; Restore ES.
	popad					    ; Restore 32bit general registers.
	clc					    ; No errors :).
	ret					    ; Return.

FindNextFreeFolderEntryErrorHddFat16:		    ; Label.
	mov   [ErrorCodeFat16],3		    ; Error so set right error number.
	pop   es				    ; Restore ES.
	popad					    ; Restore 32bit general registers.
	stc					    ; Errors :(.
	ret					    ; Return.

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; ReleaseClusterChainFat16.                                                        ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ReleaseClusterChainFat16:			    ; Name of function.
	pushad					    ; Save 32bit general registers.
	push  ds				    ; Save DS.
	mov   word [ClusterUPFat16],ax		    ; Save first cluster.
	mov   ax,18h				    ; Move data descriptors into AX.       
	mov   ds,ax				    ; Now add AX to DS (NO direct segment reg addressing).       
ReleaseClusterChainFat16Loop:			    ; Label.
	mov   ax,word [ClusterUPFat16]		    ; Get cluster number
	mov   bx,0x0000 			    ; Get update value
	call  UpdateClusterValueHddFat16	    ; Call function.
	mov   dx,[ClustOrigValue]		    ; Get what was stored there
	mov   word [ClusterUPFat16],dx		    ; Use it as next cluster                       
	cmp   dx,0xFFF0 			    ; Check for end.                       
	jb    ReleaseClusterChainFat16Loop	    ; if not do another loop.

ReleaseClusterChainFat16Exit:			    ; Label.
	pop   ds				    ; Restore DS.
	popad					    ; Restore 32bit general registers.
	ret					    ; Return.

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; MakeFolderHddFat.                                                                ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
MakeFolderHddFat:				    ; Name of function.
	mov   [ErrorCodeFat16],0		    ; Make sure the var is 0.
	mov   [HddSectorsWriteCountFat16],0	    ; Make sure the var is 0.
	mov   [FileLoadCountFat16],dword 0	    ; Make sure the var is 0.
	mov   [ErrorCodeFat16],1		    ; set error code to 1 = "only can make newfolder in root dir"
	cmp   [RootYesNoC],0			    ; Check if we are writing to root dir.
	jne   writeCommandErrorFat16Folder1	    ; Miss next bit if we are.
	mov   dword[NameOfFileToMakeFat16],esi	    ; ESI should point to name of file, save it.
	mov   edi,DirEntry			    ; EDI should point to address of file, save it.
	mov   dword[LoadFileFromAddressFat16],edi   ; Store folder layout buffer.
	mov   edi,0x150000
	mov   ecx,64*128
	xor   eax,eax
	cld
	rep   stosd
	xor   eax,eax
	mov   al,[bpbSectorsPerCluster1]
	dec   eax
	shl   eax,9
	mov   dword[FileSizeInBytesFat16],eax	    ; EAX should = file size in bytes, save it.
	cmp   byte[ds:esi],' '			    ; Check that the file name is valid.
	je    writeCommandNameErrorFat16Folder1     ; If not jump to exit and set error flag.
	cmp   byte[ds:esi],0			    ; Check that the file name is valid.
	je    writeCommandNameErrorFat16Folder1     ; If not jump to exit and set error flag.
	call  LoadMBR				    ; Make sure MBR has bean loaded.
	jc    writeCommandErrorFat16Folder1	    ; If we have a error jump exit, set error flag.
	call  ReadOneSector			    ; Load FAT and ROOT dir.       
	jc    writeCommandErrorFat16Folder1	    ; If we have a error jump exit,set error flag.
	pushad					    ; Save 32bit general registers.
	push  es				    ; Save ES.
	push  ds				    ; Save DS.
	mov   ax,18h				    ; Move data descriptors into AX.
	mov   ds,ax				    ; Now add AX to DS (NO direct segment reg addressing).       
	mov   es,ax				    ; Now add AX to ES (NO direct segment reg addressing). 
	mov   edi,FileEntry			    ; Point edi to file entry address.
	mov   ecx,0x4000			    ; Move 8 into count reg.
	xor   eax,eax				    ; Make sure EAX is 0.
	cld					    ; L to R
	rep   stosd				    ; Fill dir entry with 0.
	mov   edi,RootDirBufferHdd		    ; Load root buffer into edi.
	mov   [RootDirBufferVarC],edi		    ; Store it.
	cmp   byte[FatID],32			    ; Check for fat32.
	jne   WriteFileRootDirFolder		    ; If not we have a error.
	call  HddFat32MakeFolder		    ; Call the function.
	jc    writeCommandErrorFat16Folder	    ; test for errors.
	jmp   WriteFileHddSucsessFolder 	    ; if not we have sucess
WriteFileRootDirFolder: 			    ; Label.
	cmp   byte[FatID],16			    ; Check for fat16.
	jne   writeCommandErrorFat16Folder	    ; If not try Fat32.
	call  HddFat16MakeFolder		    ; If fat16 call function.
	jc    writeCommandErrorFat16Folder	    ; Test if it returns with error.
WriteFileHddSucsessFolder:			    ; Label.
	pop   ds				    ; Restore DS.
	pop   es				    ; Restore DS.
	popad					    ; Restore 32bit general registers.
	mov   ebx,dword[HddSectorsWriteCountFat16]  ; Number of Sectors written.
	mov   edx,NameOfFileToLoadBufferFat16	    ; Name of file written.
	mov   ah,0				    ; Mark no errors.
	clc					    ; No errors :).
	ret					    ; Return.

writeCommandErrorFat16Folder:			    ; Label.
	pop   ds				    ; Restore DS.
	pop   es				    ; Restore ES.
	popad					    ; Restore 32bit general registers.
writeCommandErrorFat16Folder1:
	mov   ah,byte[ErrorCodeFat16]		    ; Return error code.
	stc					    ; Error :(.
	ret					    ; Return.

writeCommandNameErrorFat16Folder:		    ; Label.
	pop   ds				    ; Restore DS.
	pop   es				    ; Restore ES.
	popad					    ; Restore 32bit general registers.
writeCommandNameErrorFat16Folder1:
	mov   ah,8				    ; Return error code.
	stc					    ; Error :(.                   
	ret					    ; Return.

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; HddFat16MakeFolder.                                                              ;; cccc
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
HddFat16MakeFolder:				    ; Name of function.
	mov   eax,dword[FileSizeInBytesFat16]	    ; Load eax with file size
	call  GetFileSizeInClusters		    ; Convert file size from bytes, to number of clusters.
	call  UsedSectorsFat16Write		    ; We need to see if theres any space on the hdd.
	mov   [ErrorCodeFat16],5		    ; Put the right error code in error var, for next bit.
	mov   eax,dword[FreeClustersFat16]	    ; We need to move nunber of free clusters into a reg, as memory to memory is not possable
	cmp   [FileSizeInClustersFat16],eax	    ; Can we fit the file on the Hdd ?.
	ja    HddFat16MakeFolderError		    ; If not end with error.
	mov   [ErrorCodeFat16],0		    ; Put the right error code in error var, for next bit.
	call  FindNextFreeRootEntryFat16	    ; Need to find a free root entry.
	jc    HddFat16MakeFolderError		    ; If we have a error jump exit, set error flag.
	mov   esi,dword[NameOfFileToMakeFat16]	    ; We need the address of file towrite for next function, in esi.
	call  MakeNewFolderFat16		    ; Call function.
	jc    HddFat16MakeFolderError		    ; If we have a error jump exit, set error flag.
	call  MakeRootfat16			    ; this is from old code, but some parts are still used.
	call  MakeNewFolderFat16FirstSecondEntry    ; Layout the for new dir eg: zero and add first and second entrys.
	call  FillOutRootEntryFAT16		    ; Put name of file in root dir entry.
	call  UpdateClusterChainHddFat16	    ; Up date FAT.
	jc    HddFat16MakeFolderError		    ; If we have a error jump exit, set error flag.
	call  WriteFat16			    ; Write file to Hdd
	mov   dword[HddSectorsWriteCountFat16],ebx  ; EBX is returned with number of sector wrote to hdd.
	jc    HddFat16MakeFolderError		    ; If we have a error jump exit, set error flag.
	call  DirFatRootUpdateFat16		    ; If not errors write new root and fat to hdd.
	jc    HddFat16MakeFolderError		    ; If we have a error jump exit, set error flag.
	clc					    ; No errors :).
	ret					    ; Return.


HddFat16MakeFolderError:			    ; Label.
	stc					    ; Error :(.
	ret					    ; Return.

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; HddFat32MakeFolder                                                               ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
HddFat32MakeFolder:
	mov byte[ErrorCodeFat16],0xab		    ; Return error code.
	stc					    ; Error :(.
	ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; MakeNewFolderFat16                                                               ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
MakeNewFolderFat16:				    ; Name of function.
	pushad					    ; Save 32bit general registers.
	push  es				    ; Save ES.
	push  ds				    ; Save DS.
	mov   cl,[RootYesNoC]
	mov   [RootYesNoCtmp],cl
	mov   [RootYesNoC],0
	call  FindFileNameFolderMakeFat16	    ; Check for file of same name.
	mov   cl,[RootYesNoCtmp]
	mov   [RootYesNoC],cl
	jnc   CheckForSameNameFoundMakeNewFolderHddFat16  ; Is there a file same name ?.
CheckForSameNameNotFoundHddFat1622:		    ; Label.
	mov   edi,FileEntry			    ; We need to set a root entry out.
	mov   esi,NameOfFileToLoadBufferFat16	    ; First name of file.
	mov   ecx,11				    ; Number of letters 8+3
	rep   movsb				    ; move from a to b.
	mov   al,0x10				    ; this needs tp be 10h for dir
	stosb					    ; Store it
	call  GetNextClusterHddFat16		    ; Get the next free cluster for next bit.
	jc    CheckForSameNameFoundMakeNewFolderHddFat16  ; Jump error exit if no free clusters.
	mov   edi,FileCluster			    ; Point it to the cluster address.
	mov   ax,[ClusterCount] 		    ; Move next free cluster number into AX
	mov   word [StartCluster],ax		    ; Move AX into start cluster var.
	stosw					    ; Move next free cluster into 'FileCluster'
	mov   edi,FileSize			    ; Get file size address   
	mov   eax,0x00000000			    ; Move file size in bytes into eax
	stosd					    ; Set file size in root entry.
	call  FloppyTime			    ; Call time stamp function.
	mov   ax,[FddTime]			    ; Put time stamp in AX.
	mov   edi,FileTime			    ; Put address of filetime into edi.
	stosw					    ; Move whats in AX to address edi points to.
	call  FloppyDate			    ; Call Date stamp function.
	mov   ax,[FddDate]			    ; Put Date stamp in AX.
	mov   edi,FileDate			    ; Put address of fileDate into edi.
	stosw					    ; Move whats in AX to address edi points to.
	pop   ds				    ; Restore DS.
	pop   es				    ; Restore ES.
	popad					    ; Restore 32bit general registers.
	clc					    ; No errors :).
	ret					    ; Return.

CheckForSameNameFoundMakeNewFolderHddFat16:	    ; Label.
	pop   ds				    ; Restore DS.
	pop   es				    ; Restore ES.
	popad					    ; Restore 32bit general registers.
	mov   [ErrorCodeFat16],4		    ; Error so set right error number.
	stc					    ; Errors :(.
	ret					    ; Return.

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; MakeNewFolderFat16FirstSecondEntry                                               ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
MakeNewFolderFat16FirstSecondEntry:		    ; Name of function.
	pushad					    ; Save 32bit general registers.
	push  es				    ; Save ES.
	push  ds				    ; Save DS.
	mov   edi,DirEntry			    ; Points to start of first entry in new folder.
	mov   esi,NewFolderRootDirEntryFirst	    ; First entry of dir, eg: .
	mov   ecx,11				    ; Number of letters 8+3
	rep   movsb				    ; move from a to b.
	mov   al,0x10				    ; Put 10h for subdir
	stosb					    ; Store it
	mov   edi,dirCluster			    ; Point it to the cluster address.
	mov   ax,[StartCluster] 		    ; Move next free cluster number into AX
	stosw					    ; Move next free cluster into 'FileCluster'
	mov   edi,dirSize			    ; Get file size address
	mov   eax,0x00000000			    ; Move file size in bytes into eax
	stosd					    ; Set file size in root entry.
	call  FloppyTime			    ; Call time stamp function.
	mov   ax,[FddTime]			    ; Put time stamp in AX.
	mov   edi,dirTime			    ; Put address of filetime into edi.
	stosw					    ; Move whats in AX to address edi points to.
	call  FloppyDate			    ; Call Date stamp function.
	mov   ax,[FddDate]			    ; Put Date stamp in AX.
	mov   edi,dirDate			    ; Put address of fileDate into edi.
	stosw					    ; Move whats in AX to address edi points to.
	mov   edi,DirEntry1			    ; We need to set a second entry eg: ..
	mov   esi,NewFolderRootDirEntrySecond	    ; First entry of dir.
	mov   ecx,11				    ; Number of letters 8+3
	rep   movsb				    ; move from a to b.
	mov   al,0x10				    ; Put 10h for subdir
	stosb					    ; Store it
	mov   edi,dirCluster1			    ; Point it to the cluster address.
	xor   ax,ax				    ; Zero ax, as we set this cluster to 0
	stosw					    ; Store it
	mov   edi,dirSize1			    ; Get file size address
	mov   eax,0x00000000			    ; Move file size in bytes into eax
	stosd					    ; Set file size in root entry.
	call  FloppyTime			    ; Call time stamp function.
	mov   ax,[FddTime]			    ; Put time stamp in AX.
	mov   edi,dirTime1			    ; Put address of filetime into edi.
	stosw					    ; Move whats in AX to address edi points to.
	call  FloppyDate			    ; Call Date stamp function.
	mov   ax,[FddDate]			    ; Put Date stamp in AX.
	mov   edi,dirDate1			    ; Put address of fileDate into edi.
	stosw					    ; Move whats in AX to address edi points to.
	pop   ds				    ; Restore DS.
	pop   es				    ; Restore ES.
	popad					    ; Restore 32bit general registers.
	ret					    ; Return.


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; MakeRootfat16                                                                    ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
MakeRootfat16:
	pushad					    ; Save 32bit general registers.
	mov   ecx,8
	mov   esi,FileEntry
	mov   edi,0x150000
	cld
	rep   movsd
	mov   edi,0x150000
	mov   al,0x00
	mov   ecx,11
	rep   stosb
	mov   edi,0x150000
	mov   al,0x2e
	stosb
	popad					    ; Restore 32bit general registers.
	ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; FindFileNameFolderMakeFat16                                                      ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
FindFileNameFolderMakeFat16:			    ; Name of function.
	pushad					    ; Save 32bit general registers.
	mov   dword[RootFileAddressFat16],0	    ; Make sure the var is 0.
	mov   dword[NameOfFileToLoadFat16],esi	    ; Save name of file to write.
	call  ConvertFileNameFat16FolderMake	    ; Convert name for uses in root entry.
	mov   edi,NameOfFileToLoadBufferFat16	    ; Converted name should be here.
	call  UpperCaseFat16			    ; Convert name to upper case.
	mov   edi,[RootDirBufferVarC]		    ; Move root buffer address into edi
	mov   esi,NameOfFileToLoadBufferFat16	    ; Move name buffer address into esi.
	mov   dx,[bpbRootEntries1]		    ; Number of root dir entrys, load in to DX.
	cmp   [RootYesNoC],0 
	je    CheckForSameNameHddFat16
	mov   dx,[FolderEntrysNumber]
CheckForSameNameHddFat16FolderMake:		    ; Label.      
	mov   cx,11				    ; Number of loops
CheckForSameNameLoopHddFat16FolderMake: 	    ; Label.    
	cmp   byte [es:edi],ch			    ; Check for no more entrys.
	je    CheckForSameNameNotFoundinRootDirHddFat16FolderMake  ; If so exit.                         
	pushad					    ; Save 32bit general registers.               
	repe  cmpsb				    ; Compare them.
	popad					    ; Restore 32bit general registers.                         
	je    CheckForSameNameFoundinRootDirHddFat16FolderMake	; Jume = to found file same name label
	add   edi, 32				    ; If not try the next root entry.
	dec   dx				    ; Sub 1 off loop count.
	jnz   CheckForSameNameLoopHddFat16FolderMake ; If 0 end.
CheckForSameNameNotFoundinRootDirHddFat16FolderMake: ; Label.      
	popad					    ; Restore 32bit general registers.
	stc					    ; Errors :(, but we want that here :).
	ret					    ; Return.

CheckForSameNameFoundinRootDirHddFat16FolderMake:   ; Label.    
	mov   dword[RootFileAddressFat16],edi	    ; Store the address in root entry, file by same name.
	popad					    ; Restore 32bit general registers.
	clc					    ; No errors :), but we want that here :(.
	ret					    ; Return.

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; ConvertFileNameFat16FolderMake.                                                  ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ConvertFileNameFat16FolderMake: 		    ; Name of function.
	pushad					    ; Save 32bit general registers.
	mov   esi,[NameOfFileToLoadFat16]	    ; Move name of file to convert.
	mov   edi,NameOfFileToLoadBufferFat16	    ; Buffer address used for converting.
	mov   ecx,8				     ; Number of letters
ConvertCliFileNameUFat16FolderMake:		    ; Label.  
	cmp   byte [ds:esi],'.' 		    ; Check a .
	je    @f				    ; Jump = to label.
	cmp   byte [ds:esi],' '
	je    @f
	cmp   byte [ds:esi],0
	je    @f
	cld					    ; Set left to right.
	movsb					    ; Move a byte.
	dec   ecx				     ; dec count.
	jnz  ConvertCliFileNameUFat16FolderMake     ; If not 0 do another loop.
	jmp   FinConertCliFnameUFat16FolderMake     ; If 0 jump label
@@:						    ; Label.  
	mov   al,0x20				    ; Put a space code in al.
	cld					    ; Set left to right.
	rep   stosb				    ; loop till cx is 0
FinConertCliFnameUFat16FolderMake:		    ; Label. 
	cmp   byte [ds:esi],'.' 		    ; Check a . ( have not been here before).
	jne   @f				    ; Not = jump other next bit.
	inc   esi				    ; Inc the pointer
@@:						    ; Label. 
	mov   ecx,3				     ; Number of Ext
	cld					    ; Set left to right.
	mov   al,' '
	rep   stosb				    ; Move from a to b.
	mov   al,0				    ; We need a 0 at end of name.
	stosb					    ; So let put one there.
	popad					    ; Restore 32bit general registers.
	ret					    ; Return.

;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Debug.                ;;
;;                       ;;
;; input                 ;;
;;  ecx = loop count     ;;
;;  esi = source to dump ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;
Debug:
@@:
	lodsb
	call write_hex8
	loop @b
	call WaitForKeyPressInt46OOH
	ret

NewFolderRootDirEntryFirst    db  ".          ",0   ; This the for the first entry in a new folder
NewFolderRootDirEntrySecond   db  "..         ",0   ; This the for the second entry in a new folder
NameOfFileToLoadBufferFat16   rb   16		    ; Buffer for working on file to write name.