;=========================================================;
; Vesa Information Block                         11/12/03 ;
;---------------------------------------------------------;
; Tests and sets up vesa, (runs in realmode).             ;
;                                                         ;
; (c) Craig Bamford, All rights reserved.                 ;
;=========================================================;

;====================================================;
; FASM VESA INFORMATION BLOCK                        ;
;====================================================;
VESA_Info:		
VESAInfo_Signature		rb	4
VESAInfo_Version		rw	1
VESAInfo_OEMStringPtr		rd	1
VESAInfo_Capabilities		rb	4
VESAInfo_VideoModePtr		rd	1
VESAInfo_TotalMemory		rw	1
VESAInfo_OEMSoftwareRev 	rw	1
VESAInfo_OEMVendorNamePtr	rd	1
VESAInfo_OEMProductNamePtr	rd	1
VESAInfo_OEMProductRevPtr	rd	1
VESAInfo_Reserved		rb	222
VESAInfo_OEMData		rb	256
;====================================================;
; VESA MODE INFORMATION                              ;
;====================================================;
Mode_Info:		
ModeInfo_ModeAttributes 	rw	1
ModeInfo_WinAAttributes 	rb	1
ModeInfo_WinBAttributes 	rb	1
ModeInfo_WinGranularity 	rw	1
ModeInfo_WinSize		rw	1
ModeInfo_WinASegment		rw	1
ModeInfo_WinBSegment		rw	1
ModeInfo_WinFuncPtr		rd	1
ModeInfo_BytesPerScanLine	rw	1
ModeInfo_XResolution		rw	1
ModeInfo_YResolution		rw	1
ModeInfo_XCharSize		rb	1
ModeInfo_YCharSize		rb	1
ModeInfo_NumberOfPlanes 	rb	1
ModeInfo_BitsPerPixel		rb	1
ModeInfo_NumberOfBanks		rb	1
ModeInfo_MemoryModel		rb	1
ModeInfo_BankSize		rb	1
ModeInfo_NumberOfImagePages	rb	1
ModeInfo_Reserved_page		rb	1
ModeInfo_RedMaskSize		rb	1
ModeInfo_RedMaskPos		rb	1
ModeInfo_GreenMaskSize		rb	1
ModeInfo_GreenMaskPos		rb	1
ModeInfo_BlueMaskSize		rb	1
ModeInfo_BlueMaskPos		rb	1
ModeInfo_ReservedMaskSize	rb	1
ModeInfo_ReservedMaskPos	rb	1
ModeInfo_DirectColorModeInfo	rb	1
; VBE 2.0 extensions
ModeInfo_PhysBasePtr		rd	1
ModeInfo_OffScreenMemOffset	rd	1
ModeInfo_OffScreenMemSize	rw	1
; VBE 3.0 extensions
ModeInfo_LinBytesPerScanLine	rw	1
ModeInfo_BnkNumberOfPages	rb	1
ModeInfo_LinNumberOfPages	rb	1
ModeInfo_LinRedMaskSize 	rb	1
ModeInfo_LinRedFieldPos 	rb	1
ModeInfo_LinGreenMaskSize	rb	1
ModeInfo_LinGreenFieldPos	rb	1
ModeInfo_LinBlueMaskSize	rb	1
ModeInfo_LinBlueFieldPos	rb	1
ModeInfo_LinRsvdMaskSize	rb	1
ModeInfo_LinRsvdFieldPos	rb	1
ModeInfo_MaxPixelClock		rd	1
; Reserved
ModeInfo_Reserved		rb	190
;====================================================;
; VESA MODE INFORMATION END                          ;
;====================================================;



