;=========================================================;
; Msg                                            11/12/06 ;
;---------------------------------------------------------;
;                                                         ;
; (c) Craig Bamford, All rights reserved.                 ;
;=========================================================;

LoadingGUImes:	   db "Loading gui, please wait ",13,13,0
LoadingGUImesErr   db "Error! Loading gui",13,13,0

InvalidDirMeg:	   db "Invalid directory ",13,0
CdErrorMessage:    db "Root only on D: drive",13,0
MdErrorMessage1:   db "Only works on C: drive for now",13,0
MdErrorMessage2:   db "Make dir Error!",13,0
MdErrorMessage3:   db "ERROR! MD only works from root dir, for now",13,0
Space:		   db "                        " ,0x0d,0
date_error_msg:    db "ERROR! seting date.    " ,0x0d,0
time_error_msg:    db "ERROR! seting time.    " ,0x0d,0
novesa_msg:	   db "ERROR! LFB Vesa not available. " ,0x0d,0
FloppyErrorMsg:    db "ERROR! Floppy drive not ready!. " ,0x0d,0
WeHaveFoundFile:   db "We Have Found The File! " ,0x0d,0
WeHaveNotFoundFile:   db "We Have Not Found The File! " ,0x0d,0

BiosSetMsg:	   db "Set to use BIOS read/write functions",13,0
PmodeSetMsg:	   db "Set to use Pmode read/write functions",13,0

RamSizeMsg:	   db ' MB ',0
RamMsg: 	   db 0xd2,0x02,' RamSize  ',0xd2,0x07,' - ',0
HdDriveMsg:	   db 0xd2,0x02,' HdDrive  ',0xd2,0x07,' - ',0
HdPortMsg:	   db 0xd2,0x02,' HdPort   ',0xd2,0x07,' - ',0
CdDriveMsg:	   db 0xd2,0x02,' CdDrive  ',0xd2,0x07,' - ',0
CdPortMsg:	   db 0xd2,0x02,' CdPort   ',0xd2,0x07,' - ',0
LbaYesMsg:	   db 0xd2,0x02,' LBA      ',0xd2,0x07,' - ',0xd2,0x09,'YES!',0xd2,0x07,13,0
LbaNoMsg:	   db 0xd2,0x02,' LBA      ',0xd2,0x07,' - ',0xd2,0x09,'NO!',0xd2,0x07,13, 0
VesaYesMsg:	   db 0xd2,0x02,' Vesa 2   ',0xd2,0x07,' - ',0xd2,0x09,'YES!',0xd2,0x07,13,0
VesaNoMsg:	   db 0xd2,0x02,' Vesa 2   ',0xd2,0x07,' - ',0xd2,0x09,'NO!',0xd2,0x07,13, 0
;----------------------------------------------------;
; DexOS Floppy messages                              ;
;----------------------------------------------------;
ModErrorMe:	   db 'IDE Module not found! ',13,0  
MoreErrorMsg:	   db 13, "File not found! ",0x0d,0
DirA:		   db "Directory of A:\",0
BadCommand:	   db "Bad command or file name or file extension ",0x0d,0
CdCommand:	   db "Command not implemented yet ",0x0d,0
RunFileExtError:   db "File must be a (dex) or (dem) or (bin) to Run ",0x0d,0
FloppyErrorMsgFAT12:  db "Floppy must be FAT12 ",0x0d,0

SpaceDir:	   db "    " ,0
LabelDir:	   db 0xd2,0x09,"            <Dir>  ",0xd2,0x07 ,0x0d,0
DriveCap:	   db "  drive capacity in bytes " ,0x0d,0
DriveFspace:	   db "  drive free bytes  " ,0x0d,0
DriveUsed:	   db "  drive used bytes  " ,0x0d,0
DriveFbar:	   db 177,177,177,177,177,177,177,177,177,177,177,177,177,177,177,177,0

;----------------------------------------------------;
; DexOS Cd/Dvd/Time/Date messages                    ;
;----------------------------------------------------;

DirD:		   db "Directory of D:\ ",0x0d,0x0d,0
CdDvdError:	   db "ERROR! Cd drive not ready!.  " ,0x0d,0

MesNoFatFileSys:   db "No fat16 or fat32 formatted Hdd found " ,0x0d,0
NoDriveMes:	   db "Invalid drive specification. " ,0x0d,0
Cd2YesMsg:	   db "You you can now access your 2d CD drive." ,0x0d,0
Cd2NoMsg:	   db "ERROR! No 2d CD drive found." ,0x0d,0
nextline:	   db " " ,0x0d,0
time_lable:	   db " Time ",0
date_lable:	   db " Date ",0
NotaDexProgMes:    db "This is not a valid DexOS program. " ,0x0d,0


;----------------------------------------------------;
; DexOS Commend help                                 ;
;----------------------------------------------------;

HelpMsg  db 'Thank you for using DexOS!                         ', 13
	 db 'List of supported commands:                        ', 13 
	 db 0xd2,0x02,' HELP       ',0xd2,0x07,'- Print out this list.                      ', 13
	 db 0xd2,0x02,' [f]        ',0xd2,0x07,'- Executes the file [f].                    ', 13 
	 db 0xd2,0x02,' DEL [f]    ',0xd2,0x07,'- Delete the file [f].                      ', 13
	 db 0xd2,0x02,' CLS        ',0xd2,0x07,'- Clear the screen.                         ', 13 
	 db 0xd2,0x02,' RAMDISK    ',0xd2,0x07,'- Executes the file that is in memory.      ', 13
	 db 0xd2,0x02,' DIR        ',0xd2,0x07,'- List all files/dirs on drive.             ', 13 
	 db 0xd2,0x02,' CD /[d]    ',0xd2,0x07,'- Change to the dir [d].                    ', 13
	 db 0xd2,0x02,' MD         ',0xd2,0x07,'- Makes a new dir.                          ', 13
	 db 0xd2,0x02,' A:         ',0xd2,0x07,'- Change dir to the A: drive.               ', 13 
	 db 0xd2,0x02,' C:         ',0xd2,0x07,'- Change dir to the C: drive.               ', 13 
	 db 0xd2,0x02,' D:         ',0xd2,0x07,'- Change dir to the D: drive.               ', 13 
	 db 0xd2,0x02,' VER        ',0xd2,0x07,'- Prints the kernel ver & assembly date.    ', 13  
	 db 0xd2,0x02,' TIME       ',0xd2,0x07,'- Displays current time.                    ', 13  
	 db 0xd2,0x02,' DATE       ',0xd2,0x07,'- Displays current date.                    ', 13
	 db 0xd2,0x02,' MORE [F]   ',0xd2,0x07,'- Prints text file [f], to screen.          ', 13 
	 db 0xd2,0x02,' CD2        ',0xd2,0x07,'- Lets you use 2d cd drive.                 ', 13
	 db 0xd2,0x02,' SYSINFO    ',0xd2,0x07,'- Basic sys info.                           ', 13
	 db 0xd2,0x02,' BIOS       ',0xd2,0x07,'- Use BIOS read/write functions.            ', 13
	 db 0xd2,0x02,' PMODE      ',0xd2,0x07,'- Use Pmode read/write functions.           ', 13
	 db 0xd2,0x02,' REBOOT     ',0xd2,0x07,'- Reboots the machine.                      ', 13
	 db 0xd2,0x02,' EXIT       ',0xd2,0x07,'- Exits to DOS, if in DOS, Reboots otherwise',13
	 db 'more to come!', 13, 0

;----------------------------------------------------;
; Old Messages                                       ;
;----------------------------------------------------;


msg0:		   db "  V E S A   M O D E   N O T   S U P P O R T E D !   " ,0x0d,0
