;=========================================================;
; Vdrive                                         07/28/06 ;
;---------------------------------------------------------;
;                                                         ;
; (c) Craig Bamford, All rights reserved.                 ;
;=========================================================;
LoadFile:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Load main files.                                                                 ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	cmp   [PromptLetter],'A'
	jne   TryHardDrive
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Load Module  file from Fdd.                                                      ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	call  FloppyfileLoad
	jc    DriveNotFound
	jmp   FinishedLoadingFile
TryHardDrive:
	cmp   [PromptLetter],'C'
	jne   TryCDdrive
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Load Module  file from Hdd.                                                      ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	xchg  edx,edi
	xchg  edi,esi
	call  RunCommandHdd
	jc    DriveNotFound
	jmp   FinishedLoadingFile
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Load Module  file from CD.                                                       ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
TryCDdrive:
	cmp   [PromptLetter],'D'
	jne   DriveNotFound
	call  CdfileLoad
	jc    DriveNotFound
FinishedLoadingFile:
	clc
	ret
DriveNotFound:
	stc
	ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; FindDir.                                                                         ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
FindDir:
	pushad				  
	push  es
	push  ds 
	cmp   [PromptLetter],'A'
	jne   FindDirTryHardDrive
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; FindDir Fdd.                                                                     ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	cmp   ecx,0
	je    FindDirAerrorNew
	cmp   ecx,126
	ja    FindDirAerrorNew
	mov   edi,CommandBuffer
	add   edi,3
	cld
	rep   movsb
	call  FindDirA
	jc    FindDirAerrorNew
	jmp   FinishedFindDir
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; FindDir Hdd.                                                                     ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
FindDirTryHardDrive:
	cmp   [PromptLetter],'C'
	jne   FindDirAerrorNew
	cmp   ecx,0
	je    FindDirAerrorNew
	cmp   ecx,126
	ja    FindDirAerrorNew
	mov   edi,CommandBuffer
	add   edi,3
	cld
	rep   movsb
	call  FindDirC
	jc    FindDirAerrorNew
FinishedFindDir:
	pop   ds
	pop   es
	popad
	clc
	ret  

FindDirAerrorNew:
	pop   ds
	pop   es
	popad
	stc
	ret  


