;=========================================================;
; (c) Craig Bamford, All rights reserved.                 ;
;=========================================================;

CdMenu:
      pushad
 ;----------------------------------------------------;
 ; load image to screen buffer.                       ;
 ;----------------------------------------------------; 
ReStoreCDmenu:
	call  PutBmp
	call  SaveBack
	xor   eax,eax
	mov   edx,eax
	mov   ecx,eax
	mov   ebx,eax
	mov   [MenuList],0
	mov   [MenuListCountCD],0
	mov   [LineCountCD],1
	mov   [testcount2CD],0
	mov   [DrawHighLightAddOnCD],0
	call  DrawCoverUP
	call  print_date			       ; print date 
	call  PrintTimeGui			       ; print time
	call  DrawCDmenu
	call  DrawHighLightCD
	call  PrintCdMsg
	call  BuffToScreen
 ;----------------------------------------------------;
 ; Main A: drive menu loop.                           ;
 ;----------------------------------------------------; 
CddriveMenuLoop:
	call  PutBackSave
	call  PrintDateGui  
	call  PrintTimeGui
	call  PrintCdMsg
	call  BuffToScreen
	hlt
	call  [KeyPressedScanNW]
	cmp   ax,0
	je    CddriveMenuLoop
	cmp   ah,0x50
	jne   @F
	mov   ecx,[FileNumberCountCd]
	dec   ecx
	cmp   ecx,13
	jbe   NotOver15CD
	mov   ecx,13
NotOver15CD:
	cmp   [MenuListCountCD],ecx 
	jae   CddriveMenuLoop
	add   [DrawHighLightAddOnCD],15
	inc   [MenuListCountCD]
	call  PutBmp
	call  DrawCoverUP
	call  DrawCDmenu
	call  DrawHighLightCD
	call  PrintDateGui  
	call  PrintTimeGui
	call  BuffToScreen
	call  PrintCdMsg
	jmp   CddriveMenuLoop
@@:
	cmp   ah,0x48
	jne   @F
	cmp   [MenuListCountCD],0
	jbe   CddriveMenuLoop
	sub   [DrawHighLightAddOnCD],15
	dec   [MenuListCountCD]
	call  PutBmp
	call  DrawCoverUP
	call  DrawCDmenu
	call  DrawHighLightCD
	call  PrintDateGui 
	call  PrintTimeGui  
	call  BuffToScreen
	call  PrintCdMsg
	jmp   CddriveMenuLoop
@@:
	cmp   ah,0x1c
	jne   @F
	cmp   [MenuListCountCD],0
	jne   A1CD
 ;----------------------------------------------------;
 ; Load program from floppy.                          ;
 ;----------------------------------------------------;
	mov   esi,[CdFilesForMenu]
	mov   edi,0x800000
	mov   cx,word [esi+18] ;cc
	call  [CdfileLoad]
	jc    GuiCDError
	mov   ax,18h
	mov   ds,ax
	mov   es,ax
	xor   eax,eax
	mov   ebx,eax
	mov   ecx,eax
	mov   edx,eax
	call  0x800000					
	mov   ax,18h					
	mov   ds,ax
	mov   es,ax
	xor   eax,eax
	mov   ebx,eax
	mov   ecx,eax
	mov   edx,eax
	;mov   [keybuffer],0
	jmp    CddriveMenuLoop
A1CD:
 ;----------------------------------------------------;
 ; Load program from floppy.                          ;
 ;----------------------------------------------------;
	mov   eax,[MenuListCountCD]
	mov   esi,[MenuListCountCD] 
	shl   esi,2
	shl   eax,4 
	add   esi,eax
	sub   esi,20 
	add   esi,[CdFilesForMenu]
	mov   cx,word [esi+18] ;ccc
	mov   edi,0x800000
	call  [CdfileLoad]
	jc    GuiCDError
	mov   ax,18h
	mov   ds,ax
	mov   es,ax
	xor   eax,eax
	mov   ebx,eax
	mov   ecx,eax
	mov   edx,eax
	call  0x800000					
	mov   ax,18h					
	mov   ds,ax
	mov   es,ax
	xor   eax,eax
	mov   ebx,eax
	mov   ecx,eax
	mov   edx,eax
	;mov   [keybuffer],0               
	jmp   CddriveMenuLoop
 ;----------------------------------------------------;
 ; GuiFddError.                                       ;
 ;----------------------------------------------------;
GuiCDError:
	call  GuiCdError1
	jmp   ReStoreCDmenu
@@:
	cmp   ah,0x01
	jne   CddriveMenuLoop
 ;----------------------------------------------------;
 ; Exit A: drive menu.                                ;
 ;----------------------------------------------------;
	popad
	ret

 ;----------------------------------------------------;
 ; DrawAmenu.                                         ;
 ;----------------------------------------------------;
DrawCDmenu:
	pushad
	mov   [testcount2CD],0
	mov   [vesa_fontsmall_x],100
	mov   [vesa_fontsmall_y],135
nextCD: 				
	mov   esi,[CdFilesForMenu]
	add   esi,[testcount2CD] 
	add   [testcount2CD],20
	call  print_vesa_string_small16  
	mov   [vesa_fontsmall_x],100
	mov   [vesa_fontsmall_y],150
nextCD1:				 
	mov   esi,[CdFilesForMenu]
	add   esi,[testcount2CD] 
	add   [testcount2CD],20
	call  print_vesa_string_small16  
	mov   [vesa_fontsmall_x],100
	add   [vesa_fontsmall_y],15
nextCD2:				 
	mov   esi,[CdFilesForMenu]
	add   esi,[testcount2CD] 
	add   [testcount2CD],20
	call  print_vesa_string_small16  
	mov   [vesa_fontsmall_x],100
	add   [vesa_fontsmall_y],15
nextCD3:				 
	mov   esi,[CdFilesForMenu]
	add   esi,[testcount2CD] 
	add   [testcount2CD],20
	call  print_vesa_string_small16  
	mov   [vesa_fontsmall_x],100
	add   [vesa_fontsmall_y],15
nextCD4:				 
	mov   esi,[CdFilesForMenu]
	add   esi,[testcount2CD] 
	add   [testcount2CD],20
	call  print_vesa_string_small16  
	mov   [vesa_fontsmall_x],100
	add   [vesa_fontsmall_y],15
nextCD5:				 
	mov   esi,[CdFilesForMenu]
	add   esi,[testcount2CD] 
	add   [testcount2CD],9	
	call  print_vesa_string_small16
	mov   [vesa_fontsmall_x],100
	add   [vesa_fontsmall_y],15
nextCD6:				 
	mov   esi,[CdFilesForMenu]
	add   esi,[testcount2CD] 
	add   [testcount2CD],20  
	call  print_vesa_string_small16
	mov   [vesa_fontsmall_x],100
	add   [vesa_fontsmall_y],15
nextCD7:				 
	mov   esi,[CdFilesForMenu]
	add   esi,[testcount2CD] 
	add   [testcount2CD],20  
	call  print_vesa_string_small16
	mov   [vesa_fontsmall_x],100
	add   [vesa_fontsmall_y],15
nextCD8:				 
	mov   esi,[CdFilesForMenu]
	add   esi,[testcount2CD] 
	add   [testcount2CD],20  
	call  print_vesa_string_small16
	mov   [vesa_fontsmall_x],100
	add   [vesa_fontsmall_y],15
nextCD9:				 
	mov   esi,[CdFilesForMenu]
	add   esi,[testcount2CD] 
	add   [testcount2CD],20  
	call  print_vesa_string_small16
	mov   [vesa_fontsmall_x],100
	add   [vesa_fontsmall_y],15
nextCD10:				  
	mov   esi,[CdFilesForMenu]
	add   esi,[testcount2CD] 
	add   [testcount2CD],20  
	call  print_vesa_string_small16
	mov   [vesa_fontsmall_x],100
	add   [vesa_fontsmall_y],15
nextCD11:				  
	mov   esi,[CdFilesForMenu]
	add   esi,[testcount2CD] 
	add   [testcount2CD],20  
	call  print_vesa_string_small16
	mov   [vesa_fontsmall_x],100
	add   [vesa_fontsmall_y],15
nextCD12:				  
	mov   esi,[CdFilesForMenu]
	add   esi,[testcount2CD] 
	add   [testcount2CD],20  
	call  print_vesa_string_small16
	mov   [vesa_fontsmall_x],100
	add   [vesa_fontsmall_y],15
nextCD13:				  
	mov   esi,[CdFilesForMenu]
	add   esi,[testcount2CD] 
	add   [testcount2CD],20  
	call  print_vesa_string_small16
	mov   [vesa_fontsmall_x],100
	add   [vesa_fontsmall_y],15
nextCD14:				  
	mov   esi,[CdFilesForMenu]
	add   esi,[testcount2CD] 
	call  print_vesa_string_small16
	popad
	ret

 ;----------------------------------------------------;
 ; GuiCdError1.                                       ;
 ;----------------------------------------------------;
GuiCdError1:
	pushad
	call  PutBmp
	call  DrawCoverUP
	call  PrintDateGui
	call  PrintTimeGui			       ; print time
	mov   eax,[FontColor] 
	mov   [FontColorBu],eax 
	mov   [FontColor],0x00ff4a4a
	mov   [vesa_fontsmall_x],100
	mov   [vesa_fontsmall_y],135
	mov   esi,MsgGuiCdError1
	call  print_vesa_string_small16
	mov   [vesa_fontsmall_x],100
	mov   [vesa_fontsmall_y],150
	mov   eax,[FontColorBu] 
	mov   [FontColor],eax 
	mov   esi,MsgGuiCdError2
	call  print_vesa_string_small16
	call  PrintEMsg
	call  BuffToScreen
 ;----------------------------------------------------;
 ; Main A: drive menu loop.                           ;
 ;----------------------------------------------------; 
GuiCdError1Loop:
	call  PutBackSave
	call  PrintDateGui
	call  PrintTimeGui
	call  PrintEMsg
	call  BuffToScreen
	hlt
	call  [KeyPressedScanNW]
	cmp   ax,0
	je    GuiCdError1Loop
	popad
	ret

DrawHighLightCD:
	pushad
	mov   eax,44				       ; Menu high light start X
	mov   ebx,134				       ; Menu high light start Y
	add   ebx,[DrawHighLightAddOnCD]
	mov   ecx,16				       ; Menu high light H
	mov   edx,250				       ; Menu high light W
	call  DrawWindow			       ; Draw high light
	popad
	ret

 ;----------------------------------------------------;
 ; PrintMenuMsg.                                      ;
 ;----------------------------------------------------;
PrintCdMsg:
	pushad
	mov   [vesa_fontsmall_x],445 ;404
	mov   [vesa_fontsmall_y],200 ;160
	mov   esi,CdMsg
	call  print_vesa_string_small16  
	popad
	ret
       
 ;----------------------------------------------------;
 ; Data.                                              ;
 ;----------------------------------------------------; 
FontColorBu	      dd  0
CdFilesForMenu	      dd  0
CdGuiFileCount	      dd  0
FileNumberCountCd     dd  0
MenuListCD	      dd  0
MenuListCountCD       dd  0
LineCountCD	      dd  0
testcount2CD	      dd  0
DrawHighLightAddOnCD  dd  0
CdMsg		  db ' Drive D:',0
MsgGuiCdError1:   db "READ ERROR!",0
MsgGuiCdError2:   db "Press any Key",0