;=========================================================;
; (c) Craig Bamford, All rights reserved.                 ;
;=========================================================;

 ;----------------------------------------------------;
 ; MediaPlayerMenu.                                   ;
 ;----------------------------------------------------;
MediaPlayerMenu:
	pushad
	mov   [EqXx],0 
	mov   [EQc],1
	mov   [EQc1],4
	mov   [EQc2],1
	mov   [EQc3],6
	mov   [EQc4],1
	mov   [EQc5],2
	mov   [EQc6],3
	mov   [EQc7],8
	mov   [EQc8],1
	mov   [EnterOn],0
	mov   [VisableTracks],0
	mov   [TrackNumber],0
	mov   [BusyCounter],0
	mov   [SaveTrack],0x00
	mov   [Visable1],0
	call  [TrackInFo]
	cmp   bl,0
	jne   DataCD
	cmp   al,24
	jb    @f
DataCD:
	mov   al,0
@@:
	mov   [TrackNumber],al
 ;----------------------------------------------------;
 ; load image to screen buffer.                       ;
 ;----------------------------------------------------; 
ReStoreMplayer:
	call  PutBmp
	call  SaveBack
	xor   eax,eax
	mov   edx,eax
	mov   ecx,eax
	mov   ebx,eax
	mov   [Visable],0
	mov   [SideCount],66
	mov   [MenuList],0
	mov   [MpMenuListCount],0
	mov   [LineCount],1
	mov   [testcount2],0
	mov   [DrawHighLightAddOn],0
	call  DrawCoverUP
       ;call  print_date                               ; print date 
       ;call  PrintTimeGui                             ; print time
	call  WriteTrack
	call  DrawHighLightMp
	call  DrawButtons
	call  DrawDarkTrans
	call  DrawLightTransMp
	call  PrintMpMsg
	call  DrawEq
	call  BuffToScreen
 ;----------------------------------------------------;
 ; Main A: drive menu loop.                           ;
 ;----------------------------------------------------; 
MplayerMenuLoop:

	call  PutBmp
	call  DrawCoverUP
	call  WriteTrack
	call  DrawHighLightMp
       ;call  PrintDateGui 
       ;call  PrintTimeGui 
	call  DrawButtons
	call  DrawDarkTrans
	call  DrawLightTransMp 
	call  PrintMpMsg
	call  DrawEq
	call  BuffToScreen
	call  CdBusy 
	hlt
	call  [KeyPressedScanNW]
	cmp   ax,0
	je    MplayerMenuLoop
	cmp   ah,0x50
	jne   @F
	xor   ecx,ecx
	mov   cl,[TrackNumber]
NotOver15123:
	cmp   [MpMenuListCount],cl 
	jae   MplayerMenuLoop
	add   [DrawHighLightAddOn],10
	inc   [MpMenuListCount]
	call  PutBmp
	call  DrawCoverUP
	call  WriteTrack
	call  DrawHighLightMp
	;call  PrintDateGui  
	;call  PrintTimeGui
	call  DrawButtons
	call  DrawDarkTrans
	call  DrawLightTransMp
	call  PrintMpMsg
	call  DrawEq
	call  BuffToScreen
	jmp   MplayerMenuLoop
@@:
	cmp   ah,0x48
	jne   @F
	cmp   [MpMenuListCount],0
	jbe   MplayerMenuLoop
	sub   [DrawHighLightAddOn],10
	dec   [MpMenuListCount]
	call  PutBmp
	call  DrawCoverUP
	call  WriteTrack
	call  DrawHighLightMp
	;call  PrintDateGui 
	;call  PrintTimeGui 
	call  DrawButtons
	call  DrawDarkTrans
	call  DrawLightTransMp 
	call  PrintMpMsg
	call  DrawEq
	call  BuffToScreen
	jmp   MplayerMenuLoop
@@:
	cmp   al,0x70
	jne   @F
	mov   [Visable],1
	mov   [VisableTracks],1
	mov   [SideCount],100
	cmp   [MpMenuListCount],0
	jne   JustOneTrack
	call  [PlayAllTracks] 
	cmp   al,24
	jb    PlayAllTracksOK
	mov   al,0
PlayAllTracksOK: 
	mov   [TrackNumber],al
	jmp   JustOneTrack1
JustOneTrack:
	mov   al,[MpMenuListCount]
	call  [PlayTrack]
	cmp   al,24
	jb    PlayAllTracksOKa
	mov   al,0
PlayAllTracksOKa: 
	mov   [TrackNumber],al
JustOneTrack1:
	cmp   [MpMenuListCount],al 
	jbe   NoAdd1  
	mov   [MpMenuListCount],0
	call  [PlayAllTracks] 
	mov   [DrawHighLightAddOn],0
NoAdd1:
	call  PutBmp
	call  DrawCoverUP
	call  WriteTrack
	call  DrawHighLightMp
       ; call  PrintDateGui 
       ; call  PrintTimeGui 
	call  DrawButtons
	call  DrawDarkTrans
	call  DrawLightTransMp 
	call  PrintMpMsg
	call  DrawEq
	call  BuffToScreen
	mov   [BusyCounter],188
	cmp   [TrackNumber],0
	je    MplayerMenuLoop
	mov   [Visable1],1
	mov   [EqStart],0
	mov   [EnterOn],1
	cmp   [MpMenuListCount],0
	je    MplayerMenuLoop
	mov   [EqStart],40
	jmp   MplayerMenuLoop
@@:
	cmp   al,0x50
	jne   @F
	mov   [Visable],1
	mov   [VisableTracks],1
	mov   [SideCount],100
	cmp   [MpMenuListCount],0
	jne   JustOneTracka
	call  [PlayAllTracks] 
	cmp   al,24
	jb    PlayAllTracksOKb
	mov   al,0
PlayAllTracksOKb: 
	mov   [TrackNumber],al
	jmp   JustOneTracka1
JustOneTracka:
	mov   al,[MpMenuListCount]
	call  [PlayTrack]
	cmp   al,24
	jb    PlayAllTracksOKaa
	mov   al,0
PlayAllTracksOKaa: 
	mov   [TrackNumber],al
JustOneTracka1:
	cmp   [MpMenuListCount],al 
	jbe   NoAdda1  
	mov   [MpMenuListCount],0
	call  [PlayAllTracks] 
	mov   [DrawHighLightAddOn],0
NoAdda1:
	call  PutBmp
	call  DrawCoverUP
	call  WriteTrack
	call  DrawHighLightMp
       ;call  PrintDateGui 
       ;call  PrintTimeGui 
	call  DrawButtons
	call  DrawDarkTrans
	call  DrawLightTransMp 
	call  PrintMpMsg
	call  DrawEq
	call  BuffToScreen
	mov   [BusyCounter],188
	cmp   [TrackNumber],0
	je    MplayerMenuLoop
	mov   [Visable1],1
	mov   [EqStart],0
	mov   [EnterOn],1
	cmp   [MpMenuListCount],0
	je    MplayerMenuLoop
	mov   [EqStart],40
	jmp   MplayerMenuLoop
@@:
	cmp   al,0x73
	jne   @F
	mov   [Visable],1
	mov   [SideCount],168
	call  [Stop_cd]
	mov   [Visable1],0
	mov   [EnterOn],0
	mov   [MenuList],0
	mov   [MpMenuListCount],0
	mov   [TrackNumber],0
	mov   [DrawHighLightAddOn],0
	jmp   MplayerMenuLoop
@@:
	cmp   al,0x53
	jne   @F
	mov   [Visable],1
	mov   [SideCount],168
	call  [Stop_cd]
	mov   [Visable1],0
	mov   [EnterOn],0
	mov   [MenuList],0
	mov   [MpMenuListCount],0
	mov   [TrackNumber],0
	mov   [DrawHighLightAddOn],0
	jmp   MplayerMenuLoop
@@:
	cmp   al,0x65
	jne   @F
	mov   [Visable],1
       ;mov   [VisableTracks],0
	mov   [SideCount],236
	call  [Eject_cd]
	mov   [SaveTrack],0x00
	mov   [Visable1],0
	mov   [EnterOn],0
	mov   [MenuList],0
	mov   [MpMenuListCount],0
	mov   [TrackNumber],0
	mov   [DrawHighLightAddOn],0
	jmp   MplayerMenuLoop
@@:
	cmp   al,0x45
	jne   @F
	mov   [Visable],1
	;mov   [VisableTracks],0
	mov   [SideCount],236
	call  [Eject_cd]
	mov   [SaveTrack],0x00
	mov   [Visable1],0
	mov   [EnterOn],0
	mov   [MenuList],0
	mov   [MpMenuListCount],0
	mov   [TrackNumber],0
	mov   [DrawHighLightAddOn],0
	jmp   MplayerMenuLoop
@@:
	cmp   al,0x75
	jne   @F
	mov   [Visable],1
	mov   [SideCount],134
	call  [Pause_cd]
	jmp   MplayerMenuLoop
@@:
	cmp   al,0x55
	jne   @F
	mov   [Visable],1
	mov   [SideCount],134
	call  [Pause_cd]
	jmp   MplayerMenuLoop
@@:
	cmp   al,0x63
	jne   @F
	call  [Close_cd]
	mov   [SaveTrack],0x00
	mov   [Visable1],0
	mov   [EnterOn],0
	jmp   MplayerMenuLoop
@@:
	cmp   al,0x43
	jne   @F
	call  [Close_cd]
	mov   [SaveTrack],0x00
	mov   [Visable1],0
	mov   [EnterOn],0
	jmp   MplayerMenuLoop
@@:
	cmp   ah,0x1c
	jne   @F
	cmp   [EnterOn],1
	jne   MplayerMenuLoop
	mov   [Visable],1
	mov   [VisableTracks],1
	mov   [SideCount],100
	cmp   [MpMenuListCount],0
	jne   JustOneTrackEnter
	call  [PlayAllTracks] 
	cmp   al,24
	jb    PlayAllTracksOKEnter
	mov   al,0
PlayAllTracksOKEnter: 
	mov   [TrackNumber],al
	jmp   JustOneTrack1Enter
JustOneTrackEnter:
	mov   al,[MpMenuListCount]
	call  [PlayTrack]
	cmp   al,24
	jb    PlayAllTracksOKaEnter
	mov   al,0
PlayAllTracksOKaEnter: 
	mov   [TrackNumber],al
JustOneTrack1Enter:
	cmp   [MpMenuListCount],al 
	jbe   NoAdd1Enter  
	mov   [MpMenuListCount],0
	call  [PlayAllTracks] 
	mov   [DrawHighLightAddOn],0
NoAdd1Enter:
	call  PutBmp
	call  DrawCoverUP
	call  WriteTrack
	call  DrawHighLightMp
	;call  PrintDateGui
	;call  PrintTimeGui
	call  DrawButtons
	call  DrawDarkTrans
	call  DrawLightTransMp 
	call  PrintMpMsg
	call  DrawEq
	call  BuffToScreen
	mov   [BusyCounter],188
	cmp   [TrackNumber],0
	je    MplayerMenuLoop
	mov   [Visable1],1
	mov   [EqStart],0
	cmp   [MpMenuListCount],0
	je    MplayerMenuLoop
	mov   [EqStart],40
	jmp   MplayerMenuLoop
 ;----------------------------------------------------;
 ; GuiMpError.                                        ;
 ;----------------------------------------------------;
GuiMpError:
	call  GuiCdError1
	jmp   ReStoreMplayer
@@:
	cmp   ah,0x01
	jne   MplayerMenuLoop
 ;----------------------------------------------------;
 ; Exit A: drive menu.                                ;
 ;----------------------------------------------------;
	popad
	ret

 ;----------------------------------------------------;
 ; CdBusy.                                            ;
 ;----------------------------------------------------;
CdBusy:
	pushad
	cmp   [Visable1],0
	je    CdNotBusy
	inc   [BusyCounter]
	cmp   [BusyCounter],200
	jb    CdNotBusy
	mov   [BusyCounter],0
	call  [CheckCdStateus]			 
	jc    CdNotBusy
	mov   [SaveTrack],ah
	cmp   al,0x11
	je    CdNotBusy
	cmp   al,0x13
	jne   CdNotBusy
	mov   [Visable],0
	mov   [SaveTrack],0x00
	mov   [Visable1],0
CdNotBusy:
	popad
	ret

 ;----------------------------------------------------;
 ; DrawHighLight.                                     ;
 ;----------------------------------------------------;
DrawDarkTrans:
	pushad
	mov   eax,66				       ; Menu high light start X
	mov   ebx,410				       ; Menu high light start Y
	mov   ecx,21				       ; Menu high light H
	mov   edx,204				       ; Menu high light W
	call  DrawFilledBoxTranVesa		       ; Draw high light
	popad
	ret

 ;----------------------------------------------------;
 ; DrawHighLight.                                     ;
 ;----------------------------------------------------;
DrawLightTransMp:
	pushad
	cmp   [Visable],0
	je    @f
	mov   eax,[SideCount] ;66                      ; Menu high light start X
	mov   ebx,411				       ; Menu high light start Y
	mov   ecx,19				       ; Menu high light H
	mov   edx,34				       ; Menu high light W
	call  DrawFilledBoxTranLightVesa	       ; Draw high light
@@:
	popad
	ret

 ;----------------------------------------------------;
 ; DrawHighLight.                                     ;
 ;----------------------------------------------------;
DrawHighLightMp:
	pushad
	mov   eax,44				       ; Menu high light start X
	mov   ebx,134				       ; Menu high light start Y
	add   ebx,[DrawHighLightAddOn]
	mov   ecx,10				       ; Menu high light H
	mov   edx,250				       ; Menu high light W
	call  DrawFilledBoxTranLightVesa	       ; Draw high light
	popad
	ret

 ;----------------------------------------------------;
 ; DrawButtons.                                       ;
 ;----------------------------------------------------;
DrawButtons:
	pushad
	xor   ebx,ebx
	mov   bx,[ModeInfo_XResolution] 
	shl   ebx,2
	mov   [BytesPerScanLine],ebx 
	mov   esi,Image
	add   esi,7 ;8
	mov   eax,66 
	mov   ebx,410  
	imul  ebx,[BytesPerScanLine]	
	lea   edi,[ebx+eax*4]	   
	add   edi,VesaBuffer	
	mov   ecx,20
loop11:
	push  ecx
	mov   ecx,204
loop21:
	lodsd
	shr   eax,8
	and   eax, 0xffffff
	stosd
	dec   esi
	loop  loop21
	add   edi,[BytesPerScanLine]
	sub   edi,204*4
	pop   ecx
	loop  loop11
	popad
	ret

 ;----------------------------------------------------;
 ; DrawEq.                                            ;
 ;----------------------------------------------------;
DrawEq:
	pushad
	cmp   [Visable1],1
	jne   EqXxit
	cmp   [EqStart],50
	ja    @f
	inc   [EqStart]
	jne   EqXxit
@@:
	mov   esi,ImageEQ
	mov   [ImageAddress],esi
	inc   [EqXx]
	cmp   [EqXx],2
	jb    EqXxit1
	mov   [EqXx],0
EqXxit1:
	mov   [EqX],420
	mov   [EqY],195
	inc   [EQc]
	mov   ecx,[EqXx]
	sub   [EQc],ecx
	cmp   [EQc],8
	jb    @f
	mov   [EQc],1 
@@:
	mov   ecx,[EQc]
@@:
	call  DrawEqlizer
	sub   [EqY],5
	loop  @b
	mov   [EqX],435
	mov   [EqY],195
	inc   [EQc1]
	mov   ecx,[EqXx]
	sub   [EQc1],ecx
	cmp   [EQc1],7
	jb    @f
	mov   [EQc1],1 
@@:
	mov   ecx,[EQc1]
      
@@:
	call  DrawEqlizer
	sub   [EqY],5
	loop  @b
	mov   [EqX],450
	mov   [EqY],195
	inc   [EQc2]
	mov   ecx,[EqXx]
	sub   [EQc2],ecx
	cmp   [EQc2],8
	jb    @f
	mov   [EQc2],1 
@@:
	mov   ecx,[EQc2]
@@:
	call  DrawEqlizer
	sub   [EqY],5
	loop  @b
	mov   [EqX],465
	mov   [EqY],195
	inc   [EQc3]
	mov   ecx,[EqXx]
	sub   [EQc3],ecx
	cmp   [EQc3],8
	jb    @f
	mov   [EQc3],1 
@@:
	mov   ecx,[EQc3]
@@:
	call  DrawEqlizer
	sub   [EqY],5
	loop  @b
	mov   [EqX],480
	mov   [EqY],195
	inc   [EQc4]
	mov   ecx,[EqXx]
	sub   [EQc4],ecx
	cmp   [EQc4],4
	jb    @f
	mov   [EQc4],1 
@@:
	mov   ecx,[EQc4]
@@:
	call  DrawEqlizer
	sub   [EqY],5
	loop  @b
	mov   [EqX],495
	mov   [EqY],195
	inc   [EQc5]
	mov   ecx,[EqXx]
	sub   [EQc5],ecx
	cmp   [EQc5],7
	jb    @f
	mov   [EQc5],1 
@@:
	mov   ecx,[EQc5]
@@:
	call  DrawEqlizer
	sub   [EqY],5
	loop  @b
	mov   [EqX],510
	mov   [EqY],195
	inc   [EQc6]
	mov   ecx,[EqXx]
	sub   [EQc6],ecx
	cmp   [EQc6],8
	jb    @f
	mov   [EQc6],1 
@@:
	mov   ecx,[EQc6]
@@:
	call  DrawEqlizer
	sub   [EqY],5
	loop  @b
	mov   [EqX],525
	mov   [EqY],195
	inc   [EQc7]
	mov   ecx,[EqXx]
	sub   [EQc7],ecx
	cmp   [EQc7],4
	jb    @f
	mov   [EQc7],1 
@@:
	mov   ecx,[EQc7]
@@:
	call  DrawEqlizer
	sub   [EqY],5
	loop  @b
	mov   [EqX],540
	mov   [EqY],195
	inc   [EQc8]
	mov   ecx,[EqXx]
	sub   [EQc8],ecx
	cmp   [EQc8],6
	jb    @f
	mov   [EQc8],1 
@@:
	mov   ecx,[EQc8]
@@:
	call  DrawEqlizer
	sub   [EqY],5
	loop  @b
EqXxit:
	mov   esi,ImageEQ
	mov   [ImageAddress],esi
	mov   [EqX],420
	mov   [EqY],195
	mov   ecx,9
@@:
	call  DrawEqlizer
	add   [EqX],15
	loop  @b
EqXxit2:
	popad
	ret


 ;----------------------------------------------------;
 ; DrawEqlizer.                                       ;
 ;----------------------------------------------------;
DrawEqlizer:
	pushad
	xor   ebx,ebx
	mov   bx,[ModeInfo_XResolution] 
	shl   ebx,2
	mov   [BytesPerScanLine],ebx 
	mov   esi,[ImageAddress] ;ImageEQ
	add   esi,7 ;8
	mov   eax,[EqX]
	mov   ebx,[EqY] 
	imul  ebx,[BytesPerScanLine]	
	lea   edi,[ebx+eax*4]	   
	add   edi,VesaBuffer	
	mov   ecx,5
loop11EQ:
	push  ecx
	mov   ecx,15
loop21EQ:
	;lodsd
	;shr   eax,8
	;and   eax, 0xffffff
	;stosd
	lodsd
	shr   eax,8
	and   eax, 0xffffff
	cmp   eax,00
	jne   PixelEQ
	add   edi,4
	jmp   NoPixelTBEQ
PixelEQ:
	stosd
NoPixelTBEQ:
	dec   esi
	loop  loop21EQ
	add   edi,[BytesPerScanLine]
	sub   edi,15*4
	pop   ecx
	loop  loop11EQ
	popad
	ret

 ;----------------------------------------------------;
 ; PrintMpMsg.                                        ;
 ;----------------------------------------------------;
PrintMpMsg:
	pushad
	call  ConvertYtoDec ;;;;
	mov   [vesa_fontsmall_x],454 ;404
	mov   [vesa_fontsmall_y],210 ;160
	mov   esi,MpMsg
	call  print_vesa_string_small16 
       ; mov   al,[SaveTrack]
       ; call  write_hex8
	
	popad
	ret

;====================================================;
; ConvertXtoDec.                                     ;
;====================================================;
ConvertYtoDec:
	pushad
	push  es
	push  ds
	mov   ax,18h
	mov   es,ax
	mov   ds,ax
	mov   esi,str_x
	mov   byte[str_x],' '
	mov   byte[str_x+1],' '
	mov   [str_x+2],' '
	xor   ax,ax
	mov   al,[SaveTrack]
	mov   bx,10
loopd3: 
	mov   dx,0
	div   bx
	add   dl,30h
	mov   cl,byte[ds:esi+1]
	mov   byte[ds:esi+2],cl
	mov   cl,byte[ds:esi]
	mov   byte[ds:esi+1],cl
	mov   byte [ds:esi],dl
	cmp   ax,0
	jne   loopd3
	pop   ds
	pop   es
	popad
	ret

 ;----------------------------------------------------;
 ; write hex 8                                        ;
 ;----------------------------------------------------;
write_hex8:
	pushad
	mov   edx,0x00007fde
	push  eax
	shr   al,4					   
	call  hexget	
	call  PrintVesaChar16				  
	pop   eax
	call  hexget	
	call  PrintVesaChar16	
	popad
	ret

 ;----------------------------------------------------;
 ; hexget         convers from ASCII to hexadecimal.  ;
 ;----------------------------------------------------;
hexget:
	and   eax,0x0000000f
	or    eax,0x00000030
	cmp   eax,0x39
	ja    add7
	ret
add7:	add   eax,7		
	ret

MpMsg:			 db 'Track '
str_x			 db '    ', 0
StringAddess		 dd  0
MpMsgEnd:		 db  0
SideCount		 dd  0
Visable 		 db  0
Visable1		 db  0
VisableTracks		 db  0
TrackNumber		 db  0
MpMenuListCount 	 db  0
BusyCounter		 dd  0
ConVarY 		 dw  0
TrackPlayingNumber	 db  0
SaveTrack		 db  0
ImageAddress		 dd  0
EqX			 dd  0
EqY			 dd  0
EQc			 dd  0
EQc1			 dd  0
EQc2			 dd  0
EQc3			 dd  0
EQc4			 dd  0
EQc5			 dd  0
EQc6			 dd  0
EQc7			 dd  0
EQc8			 dd  0
EqXx			 dd  0
EqStart 		 dd  0
EnterOn 		 db  0
include 'Tracks.inc'